﻿//デバッグ用
var DBG_PRT = false;//値の表示
var DBG_PTY = false;//全パーティメンバーをセット
var DBG_ITM = false;//全アイテムをセット
var DBG_CHANGE = false;//マップ切り替えの場所が判る
var DBG_BTL = false;//１歩ごとに敵が出る
var DBG_NOBTL = false;//戦闘無し
var DBG_EHP1 = false;//敵のHP1
var DBG_NOWALL = false;//壁無視
var dbgFlg = 0;

//定数
var FNT_SIZ = 36;//フォントの大きさ

//処理ごとのインデックス【制作中】
var IDX_INIT		=  0;//初期化
var IDX_TITLE		=  1;//タイトル
var IDX_MOVE		=  2;//移動シーン
var IDX_CHANGE		=  3;//場所変更
var IDX_TALK		=  4;//会話
var IDX_ITEM		=  5;//道具入手の処理
var IDX_GOLD		=  6;//お金入手の処理
var IDX_JOIN		=  7;//仲間になるイベント
var IDX_VEH_ON		=  8;//乗り物に乗る演出
var IDX_VEH_OFF		=  9;//乗り物から降りる演出
var IDX_VEHICLE		= 10;//乗り物での移動
var IDX_INN			= 20;//宿屋
var IDX_STAY		= 21;//泊まる演出
var IDX_SHOP		= 22;//店の処理
var IDX_BUY			= 23;//購入
var IDX_BUYNUM		= 24;//購入個数
var IDX_SELL		= 25;//売却
var IDX_SELLNUM		= 26;//売却個数
var IDX_EVENT		= 27;//各種のイベント
var IDX_MENU_TOP	= 30;//メニュー　トップ画面
var IDX_MENU_STS	= 31;//メニュー　能力値
var IDX_MENU_ITM	= 32;//メニュー　アイテム
var IDX_MENU_EQU	= 33;//メニュー　装備品選択画面
var IDX_MENU_USE	= 34;//メニュー　消費アイテムを使う
var IDX_MENU_MAYOKE	= 35;//メニュー　魔除け効果の演出
var IDX_MENU_DEGUCHI= 36;//メニュー　出口へ移動する演出
var IDX_MENU_WMAP	= 37;//メニュー　ワールドマップ
var IDX_MENU_SAVE	= 40;//メニュー　セーブ
var IDX_MENU_DOSAVE	= 41;//メニュー　セーブ？
var IDX_MENU_LOAD	= 42;//メニュー　ロード
var IDX_MENU_DOLOAD	= 43;//メニュー　ロード？
var IDX_BTL_INIT	= 50;//戦闘　初期化
var IDX_BTL_START	= 51;//戦闘　開始
var IDX_BTL_TURN	= 52;//戦闘　行動するキャラを決める
var IDX_BTL_CMD		= 53;//戦闘　コマンド入力
var IDX_BTL_SELSKL	= 54;//戦闘　スキル選択
var IDX_BTL_USESKL	= 55;//戦闘　スキルを使う
var IDX_BTL_SELEMY	= 56;//戦闘　敵選択
var IDX_BTL_ITM		= 57;//戦闘　戦闘中の消費アイテム選択
var IDX_BTL_USE		= 58;//戦闘　戦闘中の消費アイテム使用
var IDX_BTL_DEF		= 59;//戦闘　防御
var IDX_BTL_ESCAPE	= 60;//戦闘　逃げられるか
var IDX_BTL_ATTACK	= 61;//戦闘　単体攻撃
var IDX_BTL_ATCALL	= 62;//戦闘　全体攻撃
var IDX_BTL_AFTER	= 63;//戦闘　行動後の処理
var IDX_BTL_VIORDE	= 64;//戦闘　勝敗判定
var IDX_BTL_WIN		= 65;//戦闘　勝利
var IDX_BTL_CHKLVUP	= 66;//戦闘　レベルアップするか？
var IDX_BTL_LVUP	= 67;//戦闘　レベルアップ
var IDX_BTL_LOSE	= 68;//戦闘　敗北
var IDX_BTL_END		= 69;//戦闘　終了

//色の定義
var COL_POIA = [3, 6, 3];//毒状態で歩く時のアルファ値(÷10して使う)
var COL_RECA = [0, 0, 0, 1, 2, 3, 4, 5, 6, 6, 5, 4, 3, 2, 1, 0];//回復演出のアルファ値(÷10して使う)

//最大値の定義
var MAX_GOLD = 99999;
var MAX_ITM = 99;

//変数の宣言
var idx = 0;//┬プログラムの進行を管理
var tmr = 0;//┘
var idxBk = 0;//キャンセルした時などにどのインデックスに戻るか
var dcnt = 0;//描画(主にアニメーション)用のカウンター
var gpv = 0;//諸々汎用　その場限りで使う変数
var inp = 0;//入力汎用　その場限りで使う変数


//プレイヤーキャラの移動用
var XP = [ 0,  0, -1,  1];//各向き（上下左右）の座標変化値
var YP = [-1,  1,  0,  0];
var FACE_DIR = [1, 0, 3, 2];//会話時などにプレイヤー側に向かせる
var PLWF = 4;//何フレームで１マス動くか
var plWalk;//移動処理のフラグ（カウンター）

var gold;//所持金
var steps;//敵エンカウント歩数の管理
var mayoke;//魔除けの歩数カウント
var vehicle;//乗り物に乗っているか
var veh_spd;//乗り物の速度　※保存不要
var map_no;//プレイヤーがどのマップにいるか
var worldX, worldY;//プレイヤーのワールドマップ上の座標（町やダンジョンの出入りで使用）
var numOfPty;//パーティメンバーが何人いるか

var MENU_TOP = ["能力/装備", "道具", "地図", "乗り物", "セーブ", "ロード"];//メニュー画面の項目
var BTL_CMD = ["攻撃", "スキル", "道具", "防御", "撤退"];//戦闘コマンド　【開発メモ】「魔法」がこのゲームでは「スキル」
var SKILL = [
"無し",		"",						0,
"なぎ払い",	"敵全体にダメージ",		10,
"応援",		"全員の攻撃力が２倍に",	30,
"瞑想",		"体力と状態異常が回復",	30,
"氷の柱",	"敵一体に大ダメージ",	20,
"毒針",		"相手を毒状態にする",	10,
];

var SKL_NONE  = 0;
var SKL_NAGI  = 1;
var SKL_OUEN  = 2;
var SKL_MEISO = 3;
var SKL_KOORI = 4;
var SKL_DOKU  = 5;

var selTtl;		//タイトル画面項目選択
var selMenu;	//メニュートップ画面項目選択
var selChr;		//メニュー能力画面　キャラ選択
var selEq;		//メニュー能力画面　装備品選択
var selItm;		//メニュー道具画面
var selItmPage;	//　〃
var selAns;		//はい、いいえを選ぶ
var selShp;		//店の処理用　どの商品を買うか
var selNum;		//店の処理用　それをいくつ買うか
var selFile;	//セーブ、ロード時のファイル選択
var effRec;		//メニューでの回復演出用

//ここから下は初期化不要の変数
var talkNum;	//表示する会話データの番号
var talkNxt;	//会話データが次の文章に続くか
var talkDat;	//表示するメッセージ
var shopNum;	//店番号を管理する
var itemNum;	//購入処理で使う
var price;		//購入処理で使う
var change_type;//マップ切り替えの演出

//フラグ管理
var FLG_MAX  = 1000;//フラグの総数
var FLG_MENU =  950;//メニュー用のフラグ　１ならメニューが有効
//フラグメモ　800～イベント　900～仲間になるキャラ
var flg = [];
function initFlg() {//フラグの初期化
 for(var i = 0; i < FLG_MAX; i++) flg[i] = 0;
 flg[FLG_MENU+0] = 1;//能力／装備
 flg[FLG_MENU+1] = 1;//道具
 flg[FLG_MENU+2] = 1;//地図
 flg[FLG_MENU+3] = 1;//乗り物
 flg[FLG_MENU+4] = 1;//セーブ
 flg[FLG_MENU+5] = 1;//ロード
}

//入手アイテム管理　※ITM_MAX は ohq_item.js に記述
var ITM_PER = 8;//メニューで何個ずつアイテムを表示するか
var itf = [];//一度手に入れているかのフラグ
var itm = [];//持っている数
function initItm() {//フラグの初期化
 for(var i = 0; i < ITM_MAX; i++) {
  itf[i] = 0;
  itm[i] = 0;
 }
}
function getItm(n, val) {//手に入れる処理
 itf[n] = 1;//【開発メモ】一度手に入れたかのフラグを管理
 itm[n] += val;
 if(itm[n] > 99) {itm[n] = 99; return 1;}//上限値もあるので関数とする
 return 0;
}

function itmName(n) {//アイテムの名称を返す
 return ITEM_DATA[n*5];
}

function itmClass(n) {//アイテムの種類を返す
 return ITEM_DATA[n*5+1];
}

function itmPrice(n) {//アイテムの値段を返す
 return ITEM_DATA[n*5+2];
}

function itmPara1(n) {//アイテムのパラメータを返す
 return ITEM_DATA[n*5+3];
}

function itmAtc(cno) {//cnoキャラの装備の攻撃力増加値を返す
 var val = ITEM_DATA[sts[cno].equip[0]*5+3];
 if(sts[cno].equip[0] == 0) val = 100;//装備無しの時は100(x1)
 if(sts[cno].equip[2] > 0) {
  var ap = toInt(itmPara1(sts[cno].equip[2])/10)%10;//アクセサリーの効果
  val = val + 10*ap;
 }
 return val;
}

function itmDef(cno) {//cnoキャラの装備の防御力増加値を返す
 var val = ITEM_DATA[sts[cno].equip[1]*5+3];
 if(sts[cno].equip[1] == 0) val = 100;//装備無しの時は100(x1)
 if(sts[cno].equip[2] > 0) {
  var ap = toInt(itmPara1(sts[cno].equip[2])/100)%10;//アクセサリーの効果
  val = val + 10*ap;
 }
 return val;
}

function itmLeadoff(cno) {//cnoキャラの装備　先制攻撃効果
 if(sts[cno].equip[2] > 0) {
  if(toInt(itmPara1(sts[cno].equip[2])/1000)%10 > 0) return true;//アクセサリーの効果
 }
 return false;
}

function itmExp(cno) {//cnoキャラの装備の経験値増加の効果値を返す
 var val = 1;
 if(sts[cno].equip[2] > 0) {
  var p = toInt(itmPara1(sts[cno].equip[2])/10000)%10;
  if(p > 1) val = p;
 }
 return val;
}

function itmGldPls(cno) {//cnoキャラの装備のＧＯＬＤ増加の効果値を返す
 var val = 1;
 if(sts[cno].equip[2] > 0) {
  var p = toInt(itmPara1(sts[cno].equip[2])/100000)%10;
  if(p > 1) val = p;
 }
 return val;
}

var ACC_NOPOISON = 0x01;
function itmAcc(cno) {//アクセサリーの特殊効果
 var acc = 0x00;
 if(sts[cno].equip[2] > 0) {//アクセサリーを装備している
  if(itmPara1(sts[cno].equip[2])%10 == 1) acc = ACC_NOPOISON;
 }
 return acc;
}

function canEq(cno,ino) {//cnoのキャラ(今回は絵の番号)がinoのアイテムを装備できるか返す
 var i;
 var eq = parseInt(ITEM_DATA[ino*5+4]/Math.pow(10,3-obj[cno].p));
 if( eq&1 == 1 ) return true; else return false;
}

//マップデータの管理
var mapdata = [];
var mapname = "";
var mapname_tim = 0;
var mapW, mapH;
var mapAtt = [0, 0, 0, 0, 0, 0];//マップの属性　範囲外は何番のチップにするかなど
var bgmBak = -1;//それまで流していたＢＧＭの番号

function setMap() {//マップデータをセットする
 var mtop = 0;
 var loop = 0;
 while(true) {//データの頭出し
  mapname = MAPDATA[mtop];
  mapW = MAPDATA[mtop+1];
  mapH = MAPDATA[mtop+2];
  if(loop == map_no) break;
  loop++;
  mtop = mtop + 9 + mapW*mapH;
 }
 for(var i = 0; i < mapW*mapH; i++) mapdata[i] = MAPDATA[mtop+3+i];
 for(var i = 0; i < 6; i++) mapAtt[i] = MAPDATA[mtop+3+mapW*mapH+i];

 WALL[0] = 0;
 if(mapAtt[1] == 2) WALL[0] = 1;//宇宙の背景の場合　チップ０は壁になる

 if(bgmBak != mapAtt[2]) {//ＢＧＭの番号が変化した場合
  bgmBak = mapAtt[2];
  stopBgm();//一旦停止する
  if(bgmBak >= 0) playBgm(bgmBak);//出力
 }
}

function chipNo(x, y) {//マップチップの値を返す
 if(x < 0 || x >= mapW || y < 0 || y >= mapH) return mapAtt[0];
 return mapdata[x+y*mapW];
}

function chkWall(cn, dir) {//キャラクターの上下左右が壁か調べる
if(DBG_NOWALL == true) {//★★★デバッグ
 if(cn == 0) return false;
}
 var x = obj[cn].x + XP[dir];
 var y = obj[cn].y + YP[dir];
 if( (WALL[chipNo(x,y)]&1) == 1 ) return true;//壁
 return false;
}

function drawChip(cn, dx, dy) {//マップチップの表示
//【開発メモ】↓本来こうしたいが、ＢＧに筋が表示されてしまうので、下の４行で対応
// if(cn == 0) return;
 if(cn == 0) {
  if(0 <= mapAtt[1] && mapAtt[1] <= 3) fRect(dx, dy, CHIP_SIZE, CHIP_SIZE, COL_MARGIN[mapAtt[1]]);
  return;
 }
 var sx = 1+(CHIP_SIZE+2)*(cn%10);
 var sy = 1+(CHIP_SIZE+2)*(toInt(cn/10));
 drawImgTS(IMG_MAPCHIP, sx, sy, CHIP_SIZE, CHIP_SIZE, dx, dy, CHIP_SIZE, CHIP_SIZE);
}

function drawChipS(cn, dx, dy, siz) {//マップチップを小さく表示
 var sx = 1+(CHIP_SIZE+2)*(cn%10);
 var sy = 1+(CHIP_SIZE+2)*(toInt(cn/10));
 drawImgTS(IMG_MAPCHIP, sx, sy, CHIP_SIZE, CHIP_SIZE, dx, dy, siz, siz);
}

function drawMS(cn, dx, dy) {//マップシンボルの表示
 var sx = 96*cn;
 var sy = 96*2;
 drawImgTS(IMG_OBJECT, sx, sy, 96, 96, dx, dy, 96, 96);
}

function drawChr(cn, dx, dy, dir, wlk) {//キャラクターの表示
 var sx = 100*cn+2;
 var sy = 72*dir;
 if(wlk == true) sx += 48*(toInt(dcnt/4)%2);//歩行アニメ
 drawImgTS(IMG_HUMAN, sx, sy, 48, 72, dx, dy, 48, 72);
}

function drawFur(n, x, y) {//家具類の表示
 var sx = 96*(n%8);
 var sy = 96*toInt(n/8);
 drawImgTS(IMG_OBJECT, sx, sy, 96, 96, x-24, y-48, 96, 96);
}

//各キャラのステータス(能力)を管理
var PTY_MAX = 4;//パーティメンバーを最大何人管理するか
var EMY_MAX = 3;//敵キャラを最大何体扱うか
var EMY_TOP = PTY_MAX;//戦闘処理中に使う敵ステータスの添え字の開始番号

//ステータスを管理するクラス【開発メモ】将来的に戦闘時の敵の能力も管理する
function Sts() {
 this.name = "";//名前
 this.lev  = 0;	//レベル
 this.exp  = 0;	//経験値
 this.mh   = 0;	//体力値　最大
 this.hp   = 0;	//体力値
 this.mm   = 0;	//魔力　最大
 this.mp   = 0;	//魔力
 this.str  = 0;	//腕力
 this.def  = 0;	//防御力
 this.itl  = 0;	//知力
 this.mde  = 0;	//魔法防御
 this.agi  = 0;	//素早さ
 this.cri  = 0;	//クリティカルヒットの発生確率　【開発メモ】このゲームでは隠しパラメータ
 this.equip = [0, 0, 0];//装備品
 this.gen  = 0;	//性別／敵は特殊攻撃の番号が入る
 this.img = 0;//パーティメンバー／敵の画像番号
 this.gld = 0;//敵が落とすゴールドの値
 this.itm = 0;//敵が落とすアイテム
 this.poison = 0;//毒状態を管理
 this.btlTrn = 0;//戦闘の行動順番を管理
 this.btlAtc = 0;//戦闘中の攻撃力アップを管理
 this.btlDef = 0;//戦闘中の防御状態を管理
 this.btlEfNum = 0;//戦闘中のエフェクトの種類
 this.btlEfTmr = 0;//戦闘中のエフェクト表示時間
}

var sts = [];
function initSts() {//ステータスクラスの初期化
 for(var i = 0; i < PTY_MAX+EMY_MAX; i++) sts[i] = new Sts();
}

function setSts(no, _name, _lev, _exp, _mh, _hp, _mm, _mp, _st, _de, _it, _md, _ag, _cr, _e0, _e1, _e2, _ge, _im, _gld, _itm) {
 sts[no].name = _name;
 sts[no].lev  = _lev;
 sts[no].exp  = _exp;
 sts[no].mh   = _mh;
 sts[no].hp   = _hp;
 sts[no].mm   = _mm;
 sts[no].mp   = _mp;
 sts[no].str  = _st;
 sts[no].def  = _de;
 sts[no].itl  = _it;
 sts[no].mde  = _md;
 sts[no].agi  = _ag;
 sts[no].cri  = _cr;
 sts[no].equip[0] = _e0;
 sts[no].equip[1] = _e1;
 sts[no].equip[2] = _e2;
 sts[no].gen  = _ge;
 sts[no].img  = _im;
 sts[no].gld  = _gld;
 sts[no].itm  = _itm;
 sts[no].poison = 0;
 sts[no].btlTrn = 0;
 sts[no].btlAtc = 0;
 sts[no].btlDef = 0;
 sts[no].btlEfNum = 0;
 sts[no].btlEfTmr = 0;
}

function setChrSts(no, typ) {//ohq_status.jsで定義してあるパラメータをセットする
 typ *= 20;
 setSts( no,
  CHR_STATUS[typ+0],
  CHR_STATUS[typ+1],
  CHR_STATUS[typ+2],
  CHR_STATUS[typ+3],
  CHR_STATUS[typ+4],
  CHR_STATUS[typ+5],
  CHR_STATUS[typ+6],
  CHR_STATUS[typ+7],
  CHR_STATUS[typ+8],
  CHR_STATUS[typ+9],
  CHR_STATUS[typ+10],
  CHR_STATUS[typ+11],
  CHR_STATUS[typ+12],
  CHR_STATUS[typ+13],
  CHR_STATUS[typ+14],
  CHR_STATUS[typ+15],
  CHR_STATUS[typ+16],
  CHR_STATUS[typ+17],
  CHR_STATUS[typ+18],
  CHR_STATUS[typ+19] );

if(DBG_EHP1 == true) {//★★★デバッグ
 if(EMY_TOP+0 <= no && no <= EMY_TOP+2 ) sts[no].hp = 1;
}

}

function clrSts(no) {//ステータスをクリアする（そのキャラが存在しない状態）
 setSts(no, "", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
}

//オブジェクトの管理
var OBJ_MAX = 100;//最大いくつのオブジェを管理するか			【開発メモ】0～9の10個はパーティメンバー用
var objMax;//各マップに配置されたオブジェの数					【開発メモ】マップシンボルやNPCは配列10番から配置する
var objNum;//プレイヤーが載った（接した）オブジェクト番号

//Var0.0.5からオブジェクト管理をクラス化
function Obj() {
 this.type	= 0;//タイプ　マップシンボルなのか人間なのかなど【開発メモ】値は ohq_mapdata.js で定義している
 this.x		= 0;//┬マップチップ上の座標
 this.y		= 0;//┘
 this.cx	= 0;//┬キャンバスに表示するための座標
 this.cy	= 0;//┘
 this.p		= 0;//画像の番号
 this.d1	= 0;//各種データ【開発メモ】プレイヤーキャラとＮＰＣの向きは objD1 で管理
 this.d2	= 0;
 this.d3	= 0;
 this.d4	= 0;
 this.d5	= 0;
 this.flg	= 0;//フラグ
}

obj = [];
function initObj() {//オブジェクトクラスの初期化
 for(var i = 0; i < OBJ_MAX; i++) obj[i] = new Obj();
}

function clrObj(n) {//オブジェクトを消す
 obj[n].type = 0;//※この値が0なら存在しないものとする
}

function clrObjAll() {//全てのオブジェクトが配置されていない状態にする
 for(var i = 10; i < OBJ_MAX; i++) clrObj(i);
}

function initLeader() {//パーティメンバー先頭キャラの初期化
 setChrSts(0, 0);//勇者のパラメータをセット
 obj[0].type = OBJ_PTY;
 obj[0].x = 9;
 obj[0].y = 7;
 obj[0].p = sts[0].img;
 obj[0].d1 = 1;//向き　0上,1下,2左,3右
 map_no = 17;

obj[0].x = 97;
obj[0].y = 97;
map_no = 0;
//worldX = 60;
//worldY = 10;

//★★★熱砂デバッグ
//map_no = 21;
//obj[0].x = 22;
//obj[0].y = 22;

 obj[0].cx = obj[0].x*CHIP_SIZE;
 obj[0].cy = obj[0].y*CHIP_SIZE;
 numOfPty = 1;
}

function joinPty(stsNo) {//パーティメンバーを加える
 var n = numOfPty;
 setChrSts(n, stsNo);
 obj[n].type = OBJ_PTY;
 obj[n].x = obj[0].x + XP[obj[0].d1];
 obj[n].y = obj[0].y + YP[obj[0].d1];
 obj[n].cx = obj[n].x*CHIP_SIZE;
 obj[n].cy = obj[n].y*CHIP_SIZE;
 obj[n].p = sts[n].img;
 obj[n].d1 = FACE_DIR[obj[0].d1];
 numOfPty++;//パーティのメンバー数を増やす
}

function walkPty() {//２人目からのパーティメンバーをぞろぞろ歩かせる
 var i, xp, yp;
 for(i = 1; i < 10; i++) {
  if(obj[i].type == OBJ_PTY) {
   xp = obj[i-1].x - obj[i].x;//列の前にいるキャラが何マス離れたか
   yp = obj[i-1].y - obj[i].y;//
   if(Math.abs(xp) >= 2 || Math.abs(yp) >= 2 || xp*yp != 0) {// 横に２マス or 縦に２マス o r斜め に離れた
     obj[i].x = obj[i-1].x - XP[obj[i-1].d1];//すぐ後ろの座標とする
     obj[i].y = obj[i-1].y - YP[obj[i-1].d1];
   }
   //キャンバス上の座標を計算し、必要なら動かす
   xp = obj[i].x*CHIP_SIZE - obj[i].cx;//あるべき位置と現在の位置の差
   yp = obj[i].y*CHIP_SIZE - obj[i].cy;
   var spd = CHIP_SIZE/PLWF;
   if(yp < 0) {obj[i].d1 = 0; obj[i].cy -= spd;}
   if(yp > 0) {obj[i].d1 = 1; obj[i].cy += spd;}
   if(xp < 0) {obj[i].d1 = 2; obj[i].cx -= spd;}
   if(xp > 0) {obj[i].d1 = 3; obj[i].cx += spd;}
  }
 }
}

function gatherPty(dir) {//パーティ全員を先頭キャラの位置にする
 var i;
 for(i = 0; i < 10; i++) {
  obj[i].x  = obj[0].x;
  obj[i].y  = obj[0].y;
  obj[i].cx = obj[i].x*CHIP_SIZE;
  obj[i].cy = obj[i].y*CHIP_SIZE;
  obj[i].d1 = dir;
 }
}

function gotoPty(mn, x, y, dir) {//パーティ全員を指定場所に移動する
 map_no = mn;
 var i;
 for(i = 0; i < 10; i++) {
  obj[i].x  = x;
  obj[i].y  = y;
  obj[i].cx = obj[i].x*CHIP_SIZE;
  obj[i].cy = obj[i].y*CHIP_SIZE;
  obj[i].d1 = dir;
 }
 setObj();
 setMap();
}

function walkNpc() {//ＮＰＣを歩かせる
 var i, r, xp, yp;
 var spd = CHIP_SIZE/8;//【開発メモ】CHIP_SIZEが８の倍数である必要がある
 for(i = 10; i < objMax; i++) {
  r = rnd(1000);
  if(obj[i].type == OBJ_NPC) {
   //キャンバス上の座標を計算し、必要なら動かす
   xp = obj[i].x*CHIP_SIZE - obj[i].cx;//あるべき位置と現在の位置の差
   yp = obj[i].y*CHIP_SIZE - obj[i].cy;
   if(obj[i].d2 == _WALK && xp == 0 && yp == 0) {//歩くキャラが停止中
    if(r < 50) {//ランダムに向きを変える
     obj[i].d1 = r%4;
     continue;
    }
    else if(r < 100) {//歩く
     if(chipNo(obj[i].x, obj[i].y) == chipNo(obj[i].x+XP[obj[i].d1], obj[i].y+YP[obj[i].d1])) {//向いている先が今いる場所と同じチップ
      if(chkObj(i, obj[i].d1) == -1) {//進む先にオブジェが無い
       obj[i].x += XP[obj[i].d1];
       obj[i].y += YP[obj[i].d1];
       continue;
      }
     }
    }
   }
   if(yp < 0) {obj[i].d1 = 0; obj[i].cy -= spd;}
   if(yp > 0) {obj[i].d1 = 1; obj[i].cy += spd;}
   if(xp < 0) {obj[i].d1 = 2; obj[i].cx -= spd;}
   if(xp > 0) {obj[i].d1 = 3; obj[i].cx += spd;}
  }
 }
}

function setObj() {//オブジェクトデータをセットする
 var pos = 0;
 var loop = 0;
 clrObjAll();
 while(true) {//データの頭出し
  if(isNaN(OBJDATA[pos]) == true) {
   if(loop == map_no) break;
   loop++;
  }
  pos++;
 }
 pos++
 objMax = 10;
 while(true) {
  if(isNaN(OBJDATA[pos]) == true) break;
console.log("オブジェ配置"+objMax+" type="+OBJDATA[pos+0]+"("+OBJDATA[pos+2]+","+OBJDATA[pos+3]+")");//★★★デバッグ
  obj[objMax].type = OBJDATA[pos+0];
  obj[objMax].p  = OBJDATA[pos+1];
  obj[objMax].x  = OBJDATA[pos+2];
  obj[objMax].y  = OBJDATA[pos+3];
  obj[objMax].cx = obj[objMax].x*CHIP_SIZE;
  obj[objMax].cy = obj[objMax].y*CHIP_SIZE;
  obj[objMax].d1 = OBJDATA[pos+4];
  obj[objMax].d2 = OBJDATA[pos+5];
  obj[objMax].d3 = OBJDATA[pos+6];
  obj[objMax].d4 = OBJDATA[pos+7];
  obj[objMax].d5 = OBJDATA[pos+8];
  obj[objMax].flg = OBJDATA[pos+9];

  //宝箱（入手して空の場合）
  if(obj[objMax].type == OBJ_TBOX) {
   if(obj[objMax].d3 == _ITEM || obj[objMax].d3 == _GOLD) {
    if(flg[obj[objMax].flg] != 0) obj[objMax].d1 = 1;//宝箱を開いた絵にする
   }
  }
  //配置しないＮＰＣ
  if(obj[objMax].type == OBJ_NPC) {
   if(obj[objMax].d3 == _JOIN) {
    if(flg[obj[objMax].flg] != 0) clrObj(objMax);//仲間になったキャラは出現させない
   }
  }
  //イベント
  if(obj[objMax].type == OBJ_FUR) {
   if(obj[objMax].d3 == _EVNT) {
    if(obj[objMax].d5 == EV_LEVER) {//レバーを既に引いている場合
     if(flg[obj[objMax].flg] != 0) {
      obj[objMax].p++;
      clrObj(objMax-1);
     }
    }
   }
  }
  pos += 10;
  objMax++;
 }
}

function chkSw() {//プレイヤーのいる場所にスイッチがあるか？
 var ret = -1;
 for(var i = 10; i < objMax; i++) {
  if(obj[i].type == OBJ_SW && obj[i].x == obj[0].x && obj[i].y == obj[0].y) {ret = i; break;}
 }
 return ret;
}

function chkObj(n, dir) {//目の前にオブジェクトがあるか？　【開発メモ】プレイヤーの移動、及び、ＮＰＣの移動で使う関数
 var ret = -1, st = 0;
 var x = obj[n].x+XP[dir];
 var y = obj[n].y+YP[dir];
 if(n == 0) {//プレイヤーの場合
  st = 10;//パーティメンバーがいるかをチェックしない
  if(CN_TABLE <= chipNo(x,y) && chipNo(x,y) < CN_TABLE+CN_TAB_NUM) {//調べようとしているものがテーブルの場合、その１マス先を調べる
   x += XP[dir];
   y += YP[dir];
  }
 }
 for(var i = st; i < objMax; i++) {
//【開発中】現状パーティメンバー、ＮＰＣ、宝箱、家具を判定
  if(obj[i].type == OBJ_PTY || obj[i].type == OBJ_NPC || obj[i].type == OBJ_TBOX || obj[i].type == OBJ_FUR) {
   if(obj[i].x == x && obj[i].y == y) {ret = i; break;}
  }
 }
 return ret;
}

function drawObj() {//オブジェクトを描画する
 var i, j, n, x, y;
 //表示順番をソート処理で決める
 var sortN = [], sortY = [];
 for(i = 0; i < objMax; i++) {
  sortN[i] = i;
  sortY[i] = obj[i].cy;
  if(obj[i].type == OBJ_PTY) sortY[i] -= i;//パーティメンバーが同じマスにいる時、先頭の勇者が上に表示されるようにする
  if(obj[i].type == OBJ_FUR) sortY[i] -= 10;//家具と人間が同じ位置にいる場合、家具を下にする
  if(obj[i].type == OBJ_SW ) sortY[i] -= 1000;//スイッチは強制的に“下側”に表示
 }
 for(i = 0; i < objMax-1; i++) {//バブルソートで並び替える
  for(j = 0; j < objMax-1-i; j++) {
   if(sortY[j] > sortY[j+1]) {
    n = sortN[j]; sortN[j] = sortN[j+1]; sortN[j+1] = n;
    y = sortY[j]; sortY[j] = sortY[j+1]; sortY[j+1] = y;
   }
  }
 }

 for(i = 0; i < objMax; i++) {//表示処理
  n = sortN[i];
  if(obj[n].type == 0) continue;
  if(obj[n].type == OBJ_PTY && (idx == IDX_VEH_ON || idx == IDX_VEH_OFF || idx == IDX_VEHICLE)) continue;
  x = obj[n].cx-obj[0].cx+(7*CHIP_SIZE);//プレイヤーキャラとの相対座標
  y = obj[n].cy-obj[0].cy+(7*CHIP_SIZE);
  if(obj[n].type == OBJ_PTY || obj[n].type == OBJ_NPC) {
   y -= 32;//足元の位置
   if(-96 < x && x < 720 && -96 < y && y < 720) drawChr(obj[n].p, x, y, obj[n].d1, true);
   if(n == 0 && mayoke > 0) {//魔除けの演出
    fCir(x+24, y+36, 36, "rgba(255,255,64,0.5)");
   }
   if(n < 10) {//毒の演出
    if(poison[n] > 0) {
     fCir(x+24, y+36, 36, "rgba(255,0,0,"+(COL_POIA[3-poison[n]]/10)+")");
     poison[n]--;
    }
   }
  }
  if(obj[n].type == OBJ_SW) {
   if(obj[n].p >= 0) {//【開発メモ】マップシンボル 画像番号が-1なら表示しない
    x -= 24;//画像のセンタリング
    y -= 36;
    if(-96 < x && x < 720 && -96 < y && y < 720) drawMS(obj[n].p, x, y);
   }
   else {
    if(DBG_CHANGE) sRect(x, y, 48, 48, "red");//★★★デバッグ
   }
  }
  if(obj[n].type == OBJ_TBOX && obj[n].p != _NONE) {
   if(-96 < x && x < 720 && -96 < y && y < 720) drawFur(obj[n].p+obj[n].d1, x, y);//宝箱の表示
  }
  if(obj[n].type == OBJ_FUR && obj[n].p != _NONE) {
   if(-96 < x && x < 752 && -96 < y && y < 752) drawFur(obj[n].p, x, y);//家具の表示
  }
 }
}

//マップ（ＢＧ）の描画
var mapL, mapT, ofsX, ofsY;
function drawBG() {
 var x, y;
//【開発メモ】↓本来こうしたいが、ＢＧに筋が表示されてしまうので、drawChipにて対応
// if(mapAtt[1] >= 0) {//範囲外の色が設定されている場合
//  fRect(0, 0, 720, 720, COL_MARGIN[mapAtt[1]]);//全体を塗り潰す
// }

 if(COL_MARGIN[mapAtt[1]] == "GALAXY") {//宇宙の背景を描く場合
  x = -obj[0].cx/8;
  y = -obj[0].cy/8;
  drawImgTS(IMG_PICT, 0, 0, 240-1, 240-1, x-360, y-360, 720, 720);
  drawImgTS(IMG_PICT, 0, 0, 240-1, 240-1, x+360, y-360, 720, 720);
  drawImgTS(IMG_PICT, 0, 0, 240-1, 240-1, x-360, y+360, 720, 720);
  drawImgTS(IMG_PICT, 0, 0, 240-1, 240-1, x+360, y+360, 720, 720);
  //【開発メモ】-1しているのは、隣に置いた画像の色が入るのを防ぐため
 }
 mapL = toInt(obj[0].cx/CHIP_SIZE)-7;
 mapT = toInt(obj[0].cy/CHIP_SIZE)-7;
 ofsX = -(obj[0].cx%CHIP_SIZE);
 ofsY = -(obj[0].cy%CHIP_SIZE);
 for(y = -1; y < 16; y++) {
  var waveX = 0;
  if(mapAtt[5] == 1) waveX = toInt(8*SIN(10*((dcnt+y)%36))/1000);
  for(x = -1; x < 16; x++) {
   var c = chipNo(mapL+x,mapT+y);
   if(CN_WATER <= c && c < CN_WATER+9) {//水面の揺らぎ
    drawChip(CN_WATER_ANI[toInt(tmr/10)%4], x*CHIP_SIZE+ofsX, y*CHIP_SIZE+ofsY);
    if(c == CN_WATER+4) continue;
   }
   if(c == CN_LOOP) c = mapAtt[0];
   drawChip(c, x*CHIP_SIZE+ofsX+waveX, y*CHIP_SIZE+ofsY);
  }
 }
}

function drawFG() {
 var c, x, y;
 for(y = 0; y < 17; y++) {
  var waveX = 0;
  if(mapAtt[5] == 1) waveX = toInt(8*SIN(10*((dcnt+y)%36))/1000);
  for(x = -1; x < 16; x++) {
   c = chipNo(mapL+x,mapT+y);
   //フォアとして描画するチップ（屋根のパーツや隠し通路など）
   if(WALL[c] == 2) drawChip(c, x*CHIP_SIZE+ofsX+waveX, y*CHIP_SIZE+ofsY);
   //上下に並べて表示するチップ
   if(WALL[c] == 3) {
    if(c == CN_CANDLE-1) c += toInt(dcnt/5)%3;//蜀台のアニメーション
    drawChip(c+1, x*CHIP_SIZE+ofsX+waveX, (y-1)*CHIP_SIZE+ofsY);
   }
  }
 }
 if(mapname_tim > 0) {
  x = 360;
  y = 120;
  drawMenu(x, y, 320, 60);
  fText(mapname, x, y, FNT_SIZ, "white");
  mapname_tim--;
 }
}

//戦闘用　戦闘開始時に初期値をセットする
var boss_num;//ボス戦用　ボスの番号を入れる／-1ならザコ戦
var btlBG;	//背景の番号
var btlAct;	//誰が（行動するキャラ）
var btlTgt;	//誰を（ターゲット）
var btlCmd;	//コマンド
var btlEsc;	//撤退を選んだ回数
var selEmy;	//攻撃する敵を選ぶ
var getExp;	//獲得経験値
var getGld;	//獲得ゴールド
var sklNum; //使うスキルの番号
var sklAtc;	//スキルによる攻撃か
var offensive;//どちらの先制攻撃か 1=パーティ 2=敵
var crit;	//クリティカルヒット
var miss;	//物理攻撃を失敗
var mpShake = [];//ダメージを受けた時、敵及びパラメータ表示部を揺らす
var emyXP = [], emyYP = [];//敵表示用
var dmg = [];

var bsn;//┬繰り返し処理用　パーティ or 敵の番号
var ben;//┘

var pls_mh = 0;//レベルアップ時の成長用
var pls_mm = 0;
var pls_st = 0;
var pls_de = 0;
var pls_in = 0;
var pls_md = 0;
var pls_ag = 0;

function clrBtlVal() {//戦闘用変数の初期化
 var i;
 for(i=0; i<PTY_MAX+EMY_MAX; i++) {
  sts[i].btlTrn = 0;
  sts[i].btlAtc = 0;
  sts[i].btlDef = 0;
  sts[i].btlEfNum = 0;
  sts[i].btlEfTmr = 0;
  dmg[i] = 0;
  mpShake[i] = 0;
 }
 for(i=0; i<EMY_MAX; i++) { emyXP[i] = 0; emyYP[i] = 0; }
 btlAct = 0;
 btlTgt = 0;
 btlCmd = 0;
 btlEsc = 0;
 selEmy = 0;
 getExp = 0;
 getGld = 0;
 sklNum = SKL_NONE;
 sklAtc = false;
 offensive = 0;
 crit = 0
 miss = 0
}

function drawArrow(x, y) {//矢印の表示
 fTri(x, y+12, x-12,y-12, x+12,y-12, "black");
 fTri(x, y+10, x-10,y-10, x+10,y-10, "white");
}

function drawBBar(txt) {//戦闘画面上
 drawMenu(360, 30, 720, 60);
 fText(txt, 360, 30, FNT_SIZ, "white");
}

var BTL_PNG = [
260, 144, 120,  80,//戦闘背景
380, 144, 120,  80,
260, 224, 120,  80,
380, 224, 120,  80,
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
  0,   0,  37,  48,//ザコ敵
 37,   0,  37,  48,//　〃
 74,   0,  37,  48,//　〃
  0,  48,  60,  66,//　〃
 60,  48,  60,  66,//　〃
120,   0,  90, 100,//　〃
210,   0,  90, 100,//　〃
300,   0,  64, 100,//　〃
364,   0,  64, 100,//　〃
0,0,0,0,//ダミー
429,   0,  62,  62,//エフェクト
120, 100, 200,  40,//
429,  62,  42,  78,//
397, 108,  31,  31,//
471,  62,  15,  15,//毒
471,  77,  15,  15,//↑
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
0,0,0,0,//ダミー
  1, 141, 160, 120,//ボス
];

function drawBtlPng(n, x, y) {//戦闘用の画像
 n *= 4;
 var sx = BTL_PNG[n+0]*3;
 var sy = BTL_PNG[n+1]*3;
 var sw = BTL_PNG[n+2]*3;
 var sh = BTL_PNG[n+3]*3;
 if(n < 4*4)//Ver0.2.2より戦闘背景は２倍に拡大して表示
  drawImgTS(IMG_BTL, sx, sy, sw, sh, x, y, sw*2, sh*2);
 else
  drawImgTS(IMG_BTL, sx, sy, sw, sh, x, y, sw, sh);
}

function drawEmy(n, x, y) {//敵の表示
 n = n*4;
 var sx = BTL_PNG[n+0]*3+1;
 var sy = BTL_PNG[n+1]*3+1;
 var sw = BTL_PNG[n+2]*3-2;
 var sh = BTL_PNG[n+3]*3-2;
 drawImgTS(IMG_BTL, sx, sy, sw, sh, x-sw/2, y-sh, sw, sh);
}



//戦闘メッセージ
var btlMSG = [];//文字列
var btlMST = [];//時間管理(表示位置、透明度)
function clrBtlMsg() {
 for(var i=0; i<5; i++) { btlMSG[i] = ""; btlMST[i] = 0; }
}

function setBtlMsg(txt) {
 for(var i=0; i<5; i++) {
  if(btlMST[i] == 0) {
   btlMSG[i] = txt;
   btlMST[i] = 50;
   for(var j=0; j<5; j++) {//既にセットされていたメッセージを追い出す
    if(j != i && btlMST[j] > 10) btlMST[j] = 10;
   }
   break;
  }
 }
}

function drawBtlMsg() {
 for(var i=0; i<5; i++) {
  if(btlMST[i] > 0) {
   var a = 1.0;//アルファ値
   var y = 360;
   if(btlMST[i] < 10) { y = 360-(10-btlMST[i])*10; a = btlMST[i]/10; }
   if(btlMST[i] > 40) { y = 360+(btlMST[i]-40)*5; a = (50-btlMST[i])/10; }
   fText(btlMSG[i], 360, y+2, FNT_SIZ*0.95, "rgba(0,0,0,"+a+")");
   fText(btlMSG[i], 360, y, FNT_SIZ*0.95, "rgba(255,255,255,"+a+")");
   btlMST[i]--;
  }
 }
}

function drawBTL() {//戦闘画面
 var c, i, j, t, x, y, xp, yp;
 drawBtlPng(btlBG, 0, 60);
 fRect(0, 540, 720, 180, "rgba(0,0,0,0.5)");
 for(i=0; i<EMY_MAX; i++) {
  x = 120+240*i+emyXP[i];//┬敵の足元の中心の位置
  y = 380      +emyYP[i];//┘
  if(mpShake[EMY_TOP+i] > 0) {
     mpShake[EMY_TOP+i]--;
     x = x + rnd(9)-4;
     y = y + rnd(9)-4;
  }
  if(sts[EMY_TOP+i].hp > 0) {
   drawEmy(sts[EMY_TOP+i].img, x, y);
   if(sts[EMY_TOP+i].btlAtc > 0) drawBtlPng(25, x-45, y-45);
   if(sts[EMY_TOP+i].poison > 0) drawBtlPng(24, x,    y-45);
  }
  if(sts[EMY_TOP+i].btlEfTmr == 0) continue;

  //エフェクトの表示
  if(sts[EMY_TOP+i].btlEfNum == -1) {//物理攻撃の軌跡
   x = x + sts[EMY_TOP+i].btlEfTmr*30-90;
   y = y - sts[EMY_TOP+i].btlEfTmr*30-60;
   drawBtlPng(20, x-90, y-90);
  }
  if(sts[EMY_TOP+i].btlEfNum == SKL_KOORI) {//氷柱
   t = sts[EMY_TOP+i].btlEfTmr;
   setAlp(100-t*5);
   drawBtlPng(22, x-60, y-220);
   if(t >= 10) {
    for(j=0; j<8; j++) {
     xp = COS(45*j)/1000;
     yp = SIN(45*j)/1000;
     setAlp(t*5);
     c = (t-10)*(t-10)*2;
     drawBtlPng(23, x+xp*c-45, y-180+yp*c);
    }
   }
   setAlp(100);
  }
  sts[EMY_TOP+i].btlEfTmr--;
  if(sts[EMY_TOP+i].btlEfTmr == 0) sts[EMY_TOP+i].btlEfNum = 0;//エフェクト解除
 }
 drawBtlMsg();
 miniPara(480);

//for(i=0; i<PTY_MAX+EMY_MAX; i++) fText(i+":"+sts[i].hp+"/"+sts[i].mh+" "+sts[i].btlTrn, 360, 120+40*i, 20, "red");//★★★
}

//メニュー画面の描画用
function drawMenu(x, y, w, h) {
 fRect(x-w/2, y-h/2, w, h, "rgba(0,0,0,0.5)");
 sRect(x-w/2, y-h/2, w, h, "white");
}

function selBar(x, y, w, h) {
 fRect(x-w/2, y-h/2, w, h, "rgba(255,255,255,0.4)");
}

//所持金の加算
function getGold(val) {
  gold += val;
  if(gold > MAX_GOLD) gold = MAX_GOLD;
}

//所持金の表示
var GOLD = "gold";
function drawGold(typ) {
 var x = 360;//基本値
 var y = 100;
 var w = 360;
 var h =  60;
 var ofs = 0;
 if(typ == 0) {//メニュー
  drawMenu(x, y, w, h);
 }
 if(typ == 1) {//宿屋
  x = 180;
  y = 120;
  h = 160;
  ofs = 40;
  drawMenu(x, y, w, h);
  fText("宿泊代 " + gpv + GOLD, x, y+ofs, FNT_SIZ, "white");
 }
 if(typ == 2) {//店
  y = 40;
  drawMenu(x, y, w, h);
 }
 fText("所持金 " + gold + GOLD, x, y-ofs, FNT_SIZ, "white");
}

//はい、いいえを選ぶ処理
function inputYN(typ) {
 var x = 620;
 var y = 120;
 var w = 160;
 var h = 160;
 var ANS0 = "はい";
 var ANS1 = "いいえ";
 if(typ == 1) { ANS0 = "買う"; ANS1 = "売る"; }
 drawMenu(x, y, w, h);
 drawBtn(ANS0, x, y-40, 80, 60, FNT_SIZ, (selAns==0)?"-cyan":"-silver", 10); if(btn_on[10] == 1) selAns = 0;
 drawBtn(ANS1, x, y+40, 80, 60, FNT_SIZ, (selAns==1)?"-cyan":"-silver", 11); if(btn_on[11] == 1) selAns = 1;
 if(inkey == 38 || vkey == 38) selAns = 0;
 if(inkey == 40 || vkey == 40) selAns = 1;
}

//アイテムのメニュー画面
function drawItemMenu( cap ) {
 var c, i, col, nam;
 var x = 360;
 var y = 320;
 var w = 660;
 var h = 448;
 var imax = ITM_PER;
 if(idx == IDX_BTL_ITM || idx == IDX_BTL_USE) {
  imax = 6;//戦闘中
 }
 drawMenu(x, y-270, 400, 60);
 fText(cap, x, y-270, FNT_SIZ, "white");
 if(idx == IDX_MENU_ITM || idx == IDX_SELL) {
  drawBtn("←", x-150, y-270, 80, 80, FNT_SIZ, "-white", 22);
  drawBtn("→", x+150, y-270, 80, 80, FNT_SIZ, "-white", 23);
 }
 drawMenu(x, y, w, h);
 y = y - h/2 + 28;
 for(i = 1; i <= imax; i++) {
  if(selItm == i) selBar(x, y, 260, 40);
  c = selItmPage*ITM_PER + i;
  col = (selItm==i)?"cyan":"white";
  nam = itmName(0);
  if(itf[c] > 0) {
   nam = itmName(c);
   if(idx == IDX_MENU_EQU) {
    if(canEq(selChr,c) == false) col = (selItm==i)?"teal":"gray";//装備できないキャラの文字の色
   }
   fText(itm[c]+"ｺ", x+180, y, FNT_SIZ*0.8, col);
  }
  drawBtn(nam, x, y, 240, 40, FNT_SIZ, "-"+col, 10+i);
  y += 56;
 }
 if(selItmPage == 5) {//アクセサリーの説明文
  if(itf[40+selItm] > 0) {
   var txt = ACC_EFFECT[selItm-1];
   x = 360;
   y = 400;
   if(selItm > 4) y = 240;
   w = 40+mTextWidth(txt);
   h = 40+FNT_SIZ;
   drawMenu(x, y, w, h);
   fText(txt, x, y, FNT_SIZ, "cyan");
  }
 }
}

//メッセージを一定時間表示する処理
var imStr = "";
var imCol = "";
var imTim = 0;
function iMessage(s, c, t) {
 imStr = s;
 imCol = c;
 imTim = t;
}

function iMessageDraw() {
 if(imTim == 0) return;
 fText("", 0, 0, FNT_SIZ, "white");//【仮】文字サイズを通常の大きさに戻しておく→枠の幅計算用
 var x = 360, y = 360;
 var w = 40+mTextWidth(imStr);
 var h = 40+FNT_SIZ;
 drawMenu(x, y, w, h);
 fText(imStr, x, y, FNT_SIZ, imCol);
 imTim--;
}

//ヴァーチャルキーの表示と入力判定
var vkey = 0;
function virtualKey() {
 vkey = 0;
 if(winW > winH) {
  fRect(720, 0, 240, 720, "black");
  drawImgTS(IMG_PICT, 0, 240, 240/2, 720/2, 720, 0, 240, 720);
  drawBtn2("↑", 840,  90, 240-2, 180-2, 40, "white", 0); if(btn_on[0] > 0) vkey = 38;
  drawBtn2("↓", 840, 630, 240-2, 180-2, 40, "white", 1); if(btn_on[1] > 0) vkey = 40;
  drawBtn2("←", 780, 360, 120-2, 360-2, 40, "white", 2); if(btn_on[2] > 0) vkey = 37;
  drawBtn2("→", 900, 360, 120-2, 360-2, 40, "white", 3); if(btn_on[3] > 0) vkey = 39;

  setAlp(60);
  drawImgTS(IMG_PICT, 186, 362, 76, 76, 624-76, 624-76, 76*2, 76*2);
  setAlp(100);
  drawCBtn2("SPC", 624, 624, 72, 40, "white", 4); if(btn_on[4] > 0) vkey = 32;
 }
 else {
  fRect(0, 720, 720, 240, "black");
  drawImgTS(IMG_PICT, 120, 240, 720/2, 240/2,0, 720, 720, 240);
  drawBtn2("↑", 360, 780, 360-2, 120-2, 40, "white", 0 ); if( btn_on[0] > 0 ) vkey = 38;
  drawBtn2("↓", 360, 900, 360-2, 120-2, 40, "white", 1 ); if( btn_on[1] > 0 ) vkey = 40;
  drawBtn2("←",  90, 840, 180-2, 240-2, 40, "white", 2 ); if( btn_on[2] > 0 ) vkey = 37;
  drawBtn2("→", 630, 840, 180-2, 240-2, 40, "white", 3 ); if( btn_on[3] > 0 ) vkey = 39;

  setAlp(60);
  drawImgTS(IMG_PICT, 186, 362, 76, 76, 360-76, 624-76, 76*2, 76*2);
  setAlp(100);
  drawCBtn2("SPC", 360, 624, 72, 40, "white", 4); if(btn_on[4] > 0) vkey = 32;
 }
}

function escapeKey() {
 setAlp(60);
 drawImgTS(IMG_PICT, 120, 360, 120/2, 120/2, 40, 564, 120, 120);
 setAlp(100);
 drawBtn2("Esc", 100, 624, 120, 120, 40, "yellow", 6); if(btn_on[6] > 0) vkey = 27;
}

//ブラウザのサイズが変化した時（スマホなら縦持ち⇔横持ち）
//CWIDTH,CHEIGHT,SCALE,winW,winH変数はシステムで定義されている
function resizeCanvas() {
 var cw, ch;
 if(winW < winH) {//縦長の画面
  CWIDTH = 720;
  CHEIGHT = 960;
  cw = winW;
  ch = winW*CHEIGHT/CWIDTH;
  if(winW/winH > CWIDTH/CHEIGHT) {//縦長ではあるが（正方形に近く）上２行の値では高さが入らない場合
   ch = winH;
   cw = winH*CWIDTH/CHEIGHT;
  }
 }
 else {
  CWIDTH = 960;
  CHEIGHT = 720;
  cw = winH*CWIDTH/CHEIGHT;
  ch = winH;
  if(winW/winH < CWIDTH/CHEIGHT) {//横長ではあるが（正方形に近く）上２行の値では幅が入らない場合
   cw = winW;
   ch = winW*CHEIGHT/CWIDTH;
  }
 }
 cw = toInt(cw);
 ch = toInt(ch);
 SCALE = cw / CWIDTH;
 canvas.width = cw;
 canvas.height = ch;
 bg.scale(SCALE,SCALE);
 bg.textAlign = "center";
 bg.textBaseline = "middle";
}

//パーティメンバーの簡易パラメータ表示
function miniPara( mY ) {
 var i, x, y;
 for(i=0; i<numOfPty; i++) {
  y = mY;
  x = 90+180*i;
  if(mpShake[i] > 0) {
   mpShake[i]--;
   x = x + (rnd(5)-2)*2;
   y = y + (rnd(5)-2)*2;
  }
  drawMenu(x, y, 180, 120);
  drawChr(obj[i].p, x-76, y-56, _DirD, false);
  if(sts[i].btlAtc > 0) drawBtlPng(25, x-24, y-54);
  if(sts[i].poison > 0) drawBtlPng(24, x+20, y-54);
  fText("H" + sts[i].hp + "/" + sts[i].mh, x, y+10, FNT_SIZ*0.75, "white");
  fText("M" + sts[i].mp + "/" + sts[i].mm, x, y+42, FNT_SIZ*0.75, "white");
  if(idx == IDX_MENU_USE || idx == IDX_BTL_USE) {
   if(selChr == i) selBar(x, y, 180, 120);
  }
  //以下、戦闘で敵にスキル攻撃をされた時のエフェクト【開発メモ】敵の上に表示するエフェクトと差異があるものを個別に記述
  if(sts[i].btlEfTmr == 0) continue;
  if(sts[i].btlEfNum == SKL_KOORI) {//氷柱
   if(sts[i].btlEfTmr >= 10) {
    setAlp((21-sts[i].btlEfTmr)*5);
    fRect(x-90, y-60, 180, 120, "#48f");
   }
   else if(sts[i].btlEfTmr%2 == 0) {
    setAlp(60);
    fRect(x-90, y-60, 180, 120, "#48f");
   }
   setAlp(100);
  }
  sts[i].btlEfTmr--;
  if(sts[i].btlEfTmr == 0) sts[i].btlEfNum = 0;//エフェクト解除
 }
}

//クリックでパーティメンバーを選ぶ関数
function selPtyClick( mY ) {
 var i, x, y = mY;
 for(i=0; i<numOfPty; i++) {
  x = 90+180*i;
  drawBtn("", x, y, 172, 112, FNT_SIZ, "-white", 30+i);
  if(btn_on[30+i] > 1) selChr = i;
 }
}

//左右キーでパーティメンバーを選ぶ関数
function selPtyLRKey() {
 if(key[37] == 1 || key[37] > 10 || btn_on[2] == 1 || btn_on[2] > 10 || btn_on[22] == 1 || btn_on[22] > 10) {selEq = -1; selChr--; if(selChr < 0) selChr = numOfPty-1;}
 if(key[39] == 1 || key[39] > 10 || btn_on[3] == 1 || btn_on[3] > 10 || btn_on[23] == 1 || btn_on[23] > 10) {selEq = -1; selChr++; if(selChr > numOfPty-1) selChr = 0;}
}

var MSG_NONEED = "使う必要はありません";

function useItem(who, ino) {//who番のキャラにinoのアイテムを使う処理

 var rec = 0;//回復量
 var flg = false;//使ったかのフラグ

 if(itmClass(ino) == 1) {//体力回復
  if(sts[who].hp < sts[who].mh) {
   if(sts[who].hp == 0) {
    iMessage("復活させる必要があります", "white", 30);
   }
   else {
    rec = toInt(sts[who].mh*itmPara1(ino)/100);//回復薬の回復量はアイテムのパラメータ１
    stsUD(who, STS_HP, rec);
    iMessage("HP +" + rec, "cyan", 30);
    flg = true;
   }
  }
  else {
   iMessage(MSG_NONEED, "white", 30);
  }
 }

 if(itmClass(ino) == 2) {//魔法回復
  if(sts[who].mp < sts[who].mm) {
   if(sts[who].hp == 0) {
    iMessage("復活させる必要があります", "white", 30);
   }
   else {
    rec = toInt(sts[who].mm*itmPara1(ino)/100);//回復薬の回復量はアイテムのパラメータ１
    stsUD(who, STS_MP, rec);
    iMessage("MP +" + rec, "cyan", 30);
    flg = true;
   }
  }
  else {
   iMessage(MSG_NONEED, "white", 30);
  }
 }

 if(itmClass(ino) == 3) {//毒消し
  if(sts[who].poison > 0) {
   sts[who].poison = 0;
   iMessage("毒が消えました", "cyan", 30);
   flg = true;
  }
  else {
   iMessage(MSG_NONEED, "white", 30);
  }
 }

 if(itmClass(ino) == 4) {//完全に復活させる
  if(sts[who].hp < sts[who].mh || sts[who].mp < sts[who].mm || sts[who].poison > 0) {
   recPty(who);
   iMessage("完全回復しました", "cyan", 30);
   flg = true;
  }
  else {
   iMessage(MSG_NONEED, "white", 30);
  }
 }

 if(flg == true) itm[ino]--;//使ったら数を減らす
 return flg;

}

//パーティメンバーのステータスを変化させる関数
var STS_MH = 0;//体力最大値
var STS_HP = 1;//体力
var STS_MM = 2;//魔力最大値
var STS_MP = 3;//魔力
var STS_ST = 4;//腕力 strength
var STS_DE = 5;//防御力 defense
var STS_IN = 6;//知力 intelligence
var STS_MD = 7;//魔法防御 magic defense
var STS_AG = 8;//素早さ agility

function stsUD(no, para, val) {
 switch(para) {
  case STS_MH: sts[no].mh += val; if(sts[no].mh > 9999) sts[no].mh = 9999; break;
  case STS_HP: sts[no].hp += val; if(sts[no].hp > sts[no].mh) sts[no].hp = sts[no].mh; break;
  case STS_MM: sts[no].mm += val; if(sts[no].mm > 9999) sts[no].mm = 9999; break;
  case STS_MP: sts[no].mp += val; if(sts[no].mp > sts[no].mm) sts[no].mp = sts[no].mm; break;
  case STS_ST: sts[no].str+= val; if(sts[no].str > 999) sts[no].str = 999; break;
  case STS_DE: sts[no].def+= val; if(sts[no].def > 999) sts[no].def = 999; break;
  case STS_IN: sts[no].itl+= val; if(sts[no].itl > 999) sts[no].itl = 999; break;
  case STS_MD: sts[no].mde+= val; if(sts[no].mde > 999) sts[no].mde = 999; break;
  case STS_AG: sts[no].agi+= val; if(sts[no].agi > 999) sts[no].agi = 999; break;
 }
}

//パーティメンバーを回復させる関数
function recPty(no) {
 var sn = no;
 var en = no+1;
 if(no == -1) {sn = 0; en = numOfPty;}//引数-1で全員
 for(var i=sn; i<en; i++) {
  sts[i].hp = sts[i].mh;
  sts[i].mp = sts[i].mm;
  sts[i].poison = 0;
 }
}

//歩行時の毒の処理
var poison = new Array(10);
function poisonProc() {
 for(var i = 0; i < 10; i++) {
  if(obj[i].type == OBJ_PTY) {//メンバーが存在し
   if(sts[i].poison > 0) {//毒状態なら
    sts[i].poison--;
    if(sts[i].hp > 1) sts[i].hp--;
    poison[i] = 3;
   }
  }
 }
}

function setPoison(no, val) {//毒状態にする関数
 var sn = no;
 var en = no+1;
 if(no == -1) {sn = 0; en = numOfPty;}//引数-1で全員
 for(var i=sn; i<en; i++) {
  if(sts[i].hp > 0) {
   sts[i].poison = val;
   poison[i] = 3;
  }
 }
}

//初期化が必要な変数
function initVariable() {
 plWalk     = 0;
 gold       = 100;
 steps      = 0;
 mayoke     = 0;
 vehicle    = 0;
 veh_spd    = 0;
 map_no     = 0;
 numOfPty   = 0;

 selTtl     = 0;
 selMenu    = 0;
 selChr     = 0;
 selEq      = 0;
 selItm     = 1;
 selItmPage = 0;
 selAns     = 0;
 selShp     = 0;
 selNum     = 0;
 selFile    = 0;
 effRec     = 0;
 bgmBak     = -1;
 for(var i = 0; i < 10; i++) poison[i] = 0;
 menu_flg = [1,1,1,0,1,1];
}

//メイン処理　※メインループはWWSシステムが担っている
function mainProc() {
 var c, i, j, n, r;
 var x, y, w, h;
 var col;//色汎用
 var txt;//文字列汎用

 tmr++;
 dcnt++;

 switch(idx) {
  case IDX_INIT://初期化処理
  resizeCanvas();
  initVariable();
  initFlg();
  initItm();
if( DBG_ITM ) {//★★★デバッグ
 gold = toInt(MAX_GOLD/2);
 for(i=0;i<ITM_MAX;i++)getItm(i,99);
}
  initObj();
  initSts();
  idx = IDX_TITLE;
//  playSE(3);//タイトル用のサウンド【メモ】ブラウザ自体が画面をタップしないと流れない仕様になっている
  break;

  case IDX_TITLE://タイトル画面
  fRect(0, 0, 720, 720, "black");
  drawImg(IMG_TITLE, 60, 40);
  virtualKey();
  if(inkey == 38 || vkey == 38) selTtl = 0;
  if(inkey == 40 || vkey == 40) selTtl = 1;
  drawBtn("ＢＧＭあり", 360, 380, 240, 60, FNT_SIZ, (selTtl==0)?"-cyan":"-gray", 10); if(btn_on[10] == 1) selTtl = 0;
  drawBtn("ＢＧＭ無し", 360, 480, 240, 60, FNT_SIZ, (selTtl==1)?"-cyan":"-gray", 11); if(btn_on[11] == 1) selTtl = 1;
  if(key[32] == 1 || btn_on[4] == 1 || btn_on[10] > 1 || btn_on[11] > 1) {
   if(selTtl == 0) SOUND_ON = true;
   if(selTtl == 1) SOUND_ON = false;
   initLeader();
if( DBG_PTY ) {//★★★デバッグ
 for(i=0; i<4; i++) {
  if(i>0) joinPty(i);
//  sts[i].hp = 1;
  sts[i].poison = 0;
 }
}
   setObj();
   setMap();
   idx = IDX_MOVE;
  }
  break;

  case IDX_MOVE://プレイヤーキャラの移動
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  walkPty();//パーティメンバーをぞろぞろ引き連れて歩く処理
  walkNpc();
  if(plWalk == 0) {//停止中
   obj[0].cx = obj[0].x*CHIP_SIZE;
   obj[0].cy = obj[0].y*CHIP_SIZE;
   if(     inkey == 38 || vkey == 38) {obj[0].d1 = 0; if(chkWall(0,obj[0].d1) == false && chkObj(0,obj[0].d1) == -1) {obj[0].y--; plWalk = 1;} }
   else if(inkey == 40 || vkey == 40) {obj[0].d1 = 1; if(chkWall(0,obj[0].d1) == false && chkObj(0,obj[0].d1) == -1) {obj[0].y++; plWalk = 1;} }
   else if(inkey == 37 || vkey == 37) {obj[0].d1 = 2; if(chkWall(0,obj[0].d1) == false && chkObj(0,obj[0].d1) == -1) {obj[0].x--; plWalk = 1;} }
   else if(inkey == 39 || vkey == 39) {obj[0].d1 = 3; if(chkWall(0,obj[0].d1) == false && chkObj(0,obj[0].d1) == -1) {obj[0].x++; plWalk = 1;} }
   else if(key[32] == 1 || btn_on[4] == 1) {//【制作中】調べる、メニューを開く
    objNum = chkObj(0,obj[0].d1);
    if(objNum >= 10) {//目の前に何かある
     if(obj[objNum].type == OBJ_NPC || obj[objNum].type == OBJ_FUR) {
      obj[objNum].d1 = FACE_DIR[obj[0].d1];//プレイヤーの方に向かせる
      if(obj[objNum].d3 == _TALK || obj[objNum].d3 == _TALK2) {
       talkNum = obj[objNum].d4;
       if(obj[objNum].d3 == _TALK2 && flg[obj[objNum].flg] != 0) talkNum++;//フラグを見て会話内容を変える
       idx = IDX_TALK;
       tmr = 0;
       break;
      }
      if(obj[objNum].d3 == _JOIN) {//仲間になるイベント
       talkNum = obj[objNum].d4;
       selAns = 0;
       idx = IDX_JOIN;
       tmr = 0;
       break;
      }
      if(obj[objNum].d3 == _INN) {//宿屋
       talkNum = obj[objNum].d4;
       gpv = obj[objNum].d5 * numOfPty;//宿泊料
       selAns = 0;
       idx = IDX_INN;
       tmr = 0;
       break;
      }
      if(obj[objNum].d3 == _SHOP) {//店
       talkNum = obj[objNum].d4;
       shopNum = obj[objNum].d5;
       selAns = 0;
       idx = IDX_SHOP;
       tmr = 0;
       break;
      }
      if(obj[objNum].d3 == _EVNT) {//各種のイベント
       if(flg[obj[objNum].flg] == 0) {
        talkNum = obj[objNum].d4;
        selAns = 0;
        idx = IDX_EVENT;
        tmr = 0;
        break;
       }
      }
     }
     else if(obj[objNum].type == OBJ_TBOX) {
      if(flg[obj[objNum].flg] == 0) {//まだ開けていない
       obj[objNum].d1 = 1;//宝箱を開いた絵にする
       gpv = obj[objNum].d4;//中身（アイテムの番号）もしくは金額
       if(obj[objNum].d3 == _ITEM) {
        idx = IDX_ITEM;
        break;
       }
       if(obj[objNum].d3 == _GOLD) {
        idx = IDX_GOLD;
        break;
       }
      }
     }
    }
    //イベントが無ければメニューを開く
    idx = IDX_MENU_TOP;
   }
  }
  else {//移動中
   obj[0].cx = (obj[0].x-XP[obj[0].d1])*CHIP_SIZE + toInt(XP[obj[0].d1]*CHIP_SIZE*plWalk/PLWF);
   obj[0].cy = (obj[0].y-YP[obj[0].d1])*CHIP_SIZE + toInt(YP[obj[0].d1]*CHIP_SIZE*plWalk/PLWF);
   plWalk++;
   if(plWalk >= PLWF) {//移動終了
    steps++;//エンカウント用歩数のカウント
    if(mayoke > 0) {
     steps = 0;//敵を出さなくする
     mayoke--;
     if(mayoke == 0) iMessage("魔除けの効果が切れた", "white", 30);
    }
    poisonProc();//毒状態だった時の処理
    plWalk = 0;
    if(chipNo(obj[0].x, obj[0].y) == CN_LOOP) {//ループするチップ
     x = 0; if(obj[0].d1 == 2 || obj[0].d1 == 3) x = mapW-2;
     y = 0; if(obj[0].d1 == 0 || obj[0].d1 == 1) y = mapH-2;
     for(i = 0; i < 10; i++) {
      if(obj[i].type == OBJ_PTY) {
       obj[i].x -= XP[obj[0].d1]*x;
       obj[i].y -= YP[obj[0].d1]*y;
       obj[i].cx = obj[i].x*CHIP_SIZE;
       obj[i].cy = obj[i].y*CHIP_SIZE;
      }
     }
     break;
    }
    objNum = chkSw();
    if(objNum >= 10) {//町やダンジョンに入る
     idx = IDX_CHANGE;
     tmr = 0;
     break;
    }
    if(obj[0].x < 0 || obj[0].x >= mapW || obj[0].y < 0 || obj[0].y >= mapH) {//ワールドマップに戻る
     objNum = 0;//ワールドマップに戻るフラグとして使用
     idx = IDX_CHANGE;
     tmr = 0;
     break;
    }
    if(mapAtt[3] >= 0) {//敵が出現するマップ
if(DBG_BTL) steps = 999;//★★★デバッグ
if(DBG_NOBTL) steps = 0;//★★★デバッグ
     if(steps > 10 && rnd(100) < steps-10) {//エンカウント
      boss_num = -1;
      idx = IDX_BTL_INIT;
      tmr = 0;
     }
    }
   }
  }
  break;

  case IDX_CHANGE://マップ切り替え
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  if(tmr == 1) {
   obj[0].cx = obj[0].x*CHIP_SIZE;
   obj[0].cy = obj[0].y*CHIP_SIZE;
   walkPty();//パーティメンバーをぞろぞろ引き連れて歩く処理
   if(map_no == 0) {worldX = obj[0].x; worldY = obj[0].y;}//ワールドマップから町などに入る時は、ワールドマップ上の位置を記憶
   if(objNum == 0)//ワールドマップに戻る
    change_type = 0;
   else
    change_type = obj[objNum].d5;
  }
  if(change_type == 0) {
   if(tmr <= 20) fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*tmr+")");
   if(tmr >  20) fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*(40-tmr)+")");
  }
  if(change_type == 1) {
   setAlp(toInt(tmr*2.5));
  }
  if((change_type == 0 && tmr == 20) || (change_type == 1 && tmr == 1)) {
   if(objNum == 0) {//ワールドマップに戻る
    obj[0].x = worldX;
    obj[0].y = worldY+1;
    obj[0].d1 = 1;
    map_no = 0;
   }
   else {//町やダンジョンへ、及び、階層移動
    if(     obj[objNum].d1 < -20) map_no += (obj[objNum].d1+20);//前方に定義してあるマップへ移動
    else if(obj[objNum].d1 < -10) map_no -= (obj[objNum].d1+10);//後方に定義してあるマップへ移動
    else map_no = obj[objNum].d1;
    obj[0].x  = obj[objNum].d2;
    obj[0].y  = obj[objNum].d3;
    obj[0].d1 = obj[objNum].d4;
   }
   obj[0].cx = obj[0].x*CHIP_SIZE;
   obj[0].cy = obj[0].y*CHIP_SIZE;
   gatherPty(obj[0].d1);
   setObj();
   setMap();
   if(map_no > 0 && mapname != "") mapname_tim = 40;//地名を表示する
  }
  if(tmr == 40) {
   steps = 0;//敵エンカウント歩数をリセット
   idx = IDX_MOVE;
  }
  break;

  case IDX_ITEM://道具入手処理
  case IDX_GOLD://お金入手処理
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  x = 360;
  y = 440;
  w = 680;
  h = 180;
  drawMenu(x, y, w, h);
  if(idx == IDX_ITEM) {
   if(itm[gpv] == 99) {
    fMessage(itmName(gpv)+"が入っているが、\nこれ以上は持てない。", x-w/2+20, y-h/2+30, 60, FNT_SIZ, "white");
    if(key[32] == 1 || btn_on[4] == 1) {
     obj[objNum].d1 = 0;//宝箱を閉じた絵にする
     idx = IDX_MOVE;
    }
   }
   else {
    fMessage("入手アイテム　"+itmName(gpv), x-w/2+20, y-h/2+30, 60, FNT_SIZ, "white");
    if(key[32] == 1 || btn_on[4] == 1) {
     getItm(gpv, 1);
     flg[obj[objNum].flg] = 1;
     idx = IDX_MOVE;
    }
   }
  }
  if(idx == IDX_GOLD) {
   fMessage("入手金額　"+gpv+GOLD, x-w/2+20, y-h/2+30, 60, FNT_SIZ, "white");
   if(key[32] == 1 || btn_on[4] == 1) {
    getGold(gpv);
    flg[obj[objNum].flg] = 1;
    idx = IDX_MOVE;
   }
  }
  break;

  case IDX_VEH_ON:
  drawBG();
  drawObj();
  drawFG();
  y = (7-tmr/10)*CHIP_SIZE;
  fCir(7.5*CHIP_SIZE, 7.5*CHIP_SIZE, CHIP_SIZE/2, "rgba(0,0,0,0.5)");
  drawFur(24+obj[0].d1, 7*CHIP_SIZE, y);
  virtualKey();
  if(tmr >= 20) idx = IDX_VEHICLE;
  break;

  case IDX_VEH_OFF:
  drawBG();
  drawObj();
  drawFG();
  y = (5+tmr/10)*CHIP_SIZE;
  fCir(7.5*CHIP_SIZE, 7.5*CHIP_SIZE, CHIP_SIZE/2, "rgba(0,0,0,0.5)");
  drawFur(24+obj[0].d1, 7*CHIP_SIZE, y);
  virtualKey();
  if(tmr >= 20) idx = IDX_MOVE;
  break;

  case IDX_VEHICLE://乗り物での移動
  drawBG();
  drawObj();
  drawFG();
  fCir(7.5*CHIP_SIZE, 7.5*CHIP_SIZE, CHIP_SIZE/2, "rgba(0,0,0,0.5)");
  for(i=veh_spd; i>=0; i--) {
   setAlp(100-i*20);
   drawFur(24+obj[0].d1, 7*CHIP_SIZE-XP[obj[0].d1]*i*12, 5*CHIP_SIZE-YP[obj[0].d1]*i*12+SIN(15*(tmr%24))/200);//乗り物の画像
  }
  setAlp(50);
  drawImgTS(IMG_PICT, 240, 0, 240, 240, 0, 0, 240, 240);//世界地図
  setAlp(100);
  x = obj[0].x*2;
  y = obj[0].y*2;
  fRect(x-3, y-3, 7, 7, "black");
  fRect(x-2, y-2, 5, 5, (tmr%10<5)?"red":"yellow");//現在地の表示
  virtualKey();
  if(vehicle == 0) {//停止中
   for(i = 0; i < 10; i++) {
    if(obj[i].type == OBJ_PTY) {
     obj[i].x = obj[0].x;
     obj[i].y = obj[0].y;
     obj[i].cx = obj[0].x*CHIP_SIZE;
     obj[i].cy = obj[0].y*CHIP_SIZE;
    }
   }
   //【開発メモ】キー押しっぱなしで加速できる
   if(     inkey == 38 || vkey == 38) {obj[0].d1 = 0; obj[0].y--; if(obj[0].y<  0) obj[0].y = 119; if(veh_spd < 4) veh_spd++; vehicle = 5-veh_spd;}
   else if(inkey == 40 || vkey == 40) {obj[0].d1 = 1; obj[0].y++; if(obj[0].y>119) obj[0].y =   0; if(veh_spd < 4) veh_spd++; vehicle = 5-veh_spd;}
   else if(inkey == 37 || vkey == 37) {obj[0].d1 = 2; obj[0].x--; if(obj[0].x<  0) obj[0].x = 119; if(veh_spd < 4) veh_spd++; vehicle = 5-veh_spd;}
   else if(inkey == 39 || vkey == 39) {obj[0].d1 = 3; obj[0].x++; if(obj[0].x>119) obj[0].x =   0; if(veh_spd < 4) veh_spd++; vehicle = 5-veh_spd;}
   else if(key[32] == 1 || btn_on[4] == 1) {//降りる？
    if( (WALL[chipNo(obj[0].x,obj[0].y)]&1) == 0 && chkSw() == -1 ) {//載っているチップが壁でない　かつ　スイッチ（町や城など）が無い
     idx = IDX_VEH_OFF;
     tmr = 0;
    }
    else {
     iMessage("ここには降りられません", "yellow", 20);
    }
   }
   else { veh_spd = 0; }
  }
  if(vehicle > 0) {//移動中
   obj[0].cx = (obj[0].x-XP[obj[0].d1])*CHIP_SIZE + toInt(XP[obj[0].d1]*CHIP_SIZE*(5-vehicle)/4);
   obj[0].cy = (obj[0].y-YP[obj[0].d1])*CHIP_SIZE + toInt(YP[obj[0].d1]*CHIP_SIZE*(5-vehicle)/4);
   vehicle--;
  }
  break;

  case IDX_TALK://会話
  case IDX_JOIN://仲間になる
  case IDX_INN://宿屋
  case IDX_SHOP://店
  case IDX_EVENT://各種のイベント
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  x = 360;
  y = 440;
  w = 680;
  h = 180;
  drawMenu(x, y, w, h);
  if(tmr <= 0) break;//メッセージ表示時のワンクッション
  if(tmr == 1) {//表示するメッセージを調べ、次の文章に続く場合はフラグを立てる
   talkDat = TALK_DATA[talkNum];
   talkNxt = 0;
   if(talkDat.slice(-5) == "#NEXT") {
    talkDat = talkDat.substring(0,talkDat.length-5);
    talkNxt = 1;
   }
  }
  if(tmr%20 >= 10) {
   if(talkNxt == 1) fText("▼", x+w/2-24, y+h/2-24, FNT_SIZ*0.8, "white");
  }
  fMessage(talkDat, x-w/2+20, y-h/2+30, 60, FNT_SIZ, "white");

  if(talkNxt == 1) {//次のメッセージがある場合
   if(key[32] == 1 || btn_on[4] == 1) {
    talkNum++;
    tmr = -2;
   }
   break;
  }

  if(idx == IDX_TALK) {//会話だけの処理
   if(key[32] == 1 || btn_on[4] == 1) idx = IDX_MOVE;
  }
  if(idx == IDX_INN && gpv > 0) drawGold(1);//宿屋では所持金を表示
  if(idx == IDX_JOIN || idx == IDX_INN || idx == IDX_EVENT) {//はい、いいえを選ぶ処理
   inputYN(0);//選択肢
   if(key[32] == 1 || btn_on[4] == 1 || btn_on[10] > 1 || btn_on[11] > 1) {

    if(idx == IDX_JOIN) {
     if(selAns == 0) {//仲間にする
      joinPty(obj[objNum].d5);//誰が仲間になるか（ステータスの番号）
      flg[obj[objNum].flg] = 1;//フラグを立てる
      clrObj(objNum);
      talkNum++;
      idx = IDX_TALK;
      tmr = -2;
     }
     else {
      idx = IDX_MOVE;
     }
    }

    if(idx == IDX_INN) {
     if(selAns == 0) {//泊まる
      if(gold < gpv) {//宿泊料が足りない
       talkNum = TN_SHORTAGE;
       idx = IDX_TALK;
       tmr = -2;
      }
      else {
       idx = IDX_STAY;
       tmr = 0;
      }
     }
     else {
      idx = IDX_MOVE;
     }
    }

    if(idx == IDX_EVENT) {//各種のイベントの処理

     if(obj[objNum].d5 == EV_POISON) {//毒を浴びる
      if(selAns == 0) {//はいを選んだ場合
       setPoison(-1, 50);
       talkNum++;
       idx = IDX_TALK;
       tmr = -2;
      }
      else {
       idx = IDX_MOVE;
      }
     }

     if(obj[objNum].d5 == EV_LEVER) {//扉／鉄格子を開ける
      if(selAns == 0) {//はいを選んだ場合
       flg[obj[objNum].flg] = 1;//フラグを立てる
       obj[objNum].p++;
       clrObj(objNum-1);
       talkNum++;
       idx = IDX_TALK;
       tmr = -2;
      }
      else {
       idx = IDX_MOVE;
      }
     }

     if(obj[objNum].d5 == EV_BOSS) {//ボス戦
      if(selAns == 0) {//はいを選んだ場合
       talkNum += 2;//★★★勝利後の会話番号をセットしておく
       boss_num = obj[objNum].d2;
       idx = IDX_BTL_INIT;
       tmr = 0;
      }
      else {
       talkNum++;
       idx = IDX_TALK;
       tmr = -2;
      }
     }

    }// ～ idx == IDX_EVENT
   }
  }

  if(idx == IDX_SHOP) {//買う、売るを選ぶ処理
   escapeKey();
   inputYN(1);//選択肢
   if(key[32] == 1 || btn_on[4] == 1 || btn_on[10] > 1 || btn_on[11] > 1) {
    if(selAns == 0) {
     idx = IDX_BUY;
     selShp = 0;
    }
    else {
     idx = IDX_SELL;
     tmr = 0;//画面切り替え直後に道具を選ばないようにする
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MOVE;
  }

  break;

  case IDX_STAY://泊まる演出
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  if(tmr == 40) {
   gold -= gpv;
   gatherPty(_DirD);//位置を揃え
   recPty(-1);//全メンバー完全回復
  }
  if(tmr < 40) {
   fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.025*tmr+")");
  }
  else if(tmr < 80) {
   fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.025*(80-tmr)+")");
  }
  else {
   talkNum = TN_RECALL;
   idx = IDX_TALK;
   tmr = 0;
  }
  break;

  case IDX_BUY://購入
  case IDX_BUYNUM://購入個数
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawGold(2);
  x = 360;
  y = 310;
  w = 660;
  h = 448;
  drawMenu(x, y, w, h);
  y = y+toInt(-h/2+h/16);
  n = 8;//その店で何品売られているか
  for(i=0; i<8; i++) {
   col = (selShp==i)?"cyan":"white";
   c = SHOP_LIST[shopNum*8+i];
   if(c == 0) { n = i; break; }
   if(selShp == i) selBar(x, y, 480, 40);
   fText(itmPrice(c)+GOLD, x+120, y, FNT_SIZ*0.9, col);
   drawBtn(itmName(c), x-120, y, 280, 40, FNT_SIZ, "-"+col, 10+i);
   y += toInt(h/8);
  }
  if(idx == IDX_BUY) {
   escapeKey();
   if(key[38] == 1 || key[38] > 10 || btn_on[0] == 1 || btn_on[0] > 10) {selShp--; if(selShp < 0) selShp = n-1;}
   if(key[40] == 1 || key[40] > 10 || btn_on[1] == 1 || btn_on[1] > 10) {selShp++; if(selShp > n-1) selShp = 0;}

   inp = 0;
   for(i=0; i<n; i++) {
    if(btn_on[10+i] > 1) selShp = i;//項目を押したか
    if(btn_on[10+i] > 3) inp = 1;//長押ししたか
   }
   if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
    itemNum = SHOP_LIST[shopNum*8+selShp];//買おうとしている商品
    if(itm[itemNum] == MAX_ITM) {
     iMessage("これ以上持つことはできません", "yellow", 30);
    }
    else if(gold < itmPrice(itemNum)) {
     iMessage("お金が足りません", "yellow", 30);
    }
    else {
     idx = IDX_BUYNUM;
     selNum = 1;
     n = parseInt(gold/itmPrice(itemNum));//所持金で何個まで買えるか
     if(n+itm[itemNum] > MAX_ITM) n = MAX_ITM-itm[itemNum];//但し最大所持数を超えない
     gpv = 1; if(n > 1) gpv = n;
     break;//画面遷移直後に購入してしまわないように
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MOVE;
  }
  if(idx == IDX_BUYNUM) {
   fRect(0, 0, 720, 720, "rgba(0,0,0,0.6)");
   escapeKey();//ESCの表示が暗くならないよう、ここに
   x = 360;
   y = 310;
   w = 712;
   h = 240;
   drawMenu(x, y, w, h);
   fText(itmName(itemNum) + "は" + itm[itemNum] + "コ持っています", x, y-80, FNT_SIZ, "white");
   fText("いくつ買いますか？", x, y, FNT_SIZ, "white");
   price = itmPrice(itemNum)*selNum;
   fText(selNum, x-160, y+80, FNT_SIZ, "white");
   fText((price)+GOLD, x+160, y+80, FNT_SIZ, "white");
   drawBtn("←", x-160-100, y+80, 80, 80, FNT_SIZ, "-white", 22);
   drawBtn("→", x-160+100, y+80, 80, 80, FNT_SIZ, "-white", 23);
   if(key[37] == 1 || key[37] > 10 || btn_on[2] == 1 || btn_on[2] > 10 || btn_on[22] == 1 || btn_on[22] > 10) {selNum--; if(selNum < 1) selNum = gpv;}
   if(key[39] == 1 || key[39] > 10 || btn_on[3] == 1 || btn_on[3] > 10 || btn_on[23] == 1 || btn_on[23] > 10) {selNum++; if(selNum > gpv) selNum = 1;}
   if(key[32] == 1 || btn_on[4] == 1) {
    getItm(itemNum, selNum);
    gold -= price;
    iMessage(itmName(itemNum)+"を買いました", "white", 30);
    idx = IDX_BUY;
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_BUY;
  }
  break;

  case IDX_MENU_TOP://メニュートップ画面
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawGold(0);
  x = 360;
  y = 320;
  w = 480;
  h = 320;
  drawMenu(x, y, w, h);
  for(i = 0; i < 6; i++) {
   x = 240+240*(i%2);
   y = 220+100*toInt(i/2);
   if(selMenu == i) selBar(x, y, 180, 50);
   var men = "？";
   if(flg[FLG_MENU+i] == 1) men = MENU_TOP[i];
   drawBtn(men, x, y, 160, 60, FNT_SIZ, (selMenu==i)?"-cyan":"-white", 10+i);
  }
//【制作中】仮のメニュー項目選択
  if(key[38] == 1 || btn_on[0] == 1) if(selMenu >= 2) selMenu -= 2;
  if(key[40] == 1 || btn_on[1] == 1) if(selMenu <= 3) selMenu += 2;
  if(key[37] == 1 || btn_on[2] == 1) selMenu -= selMenu%2;
  if(key[39] == 1 || btn_on[3] == 1) selMenu += (selMenu+1)%2;

  inp = 0;
  for(i = 0; i < 6; i++) {
   if(btn_on[10+i] > 1) selMenu = i;//項目を押したか
   if(btn_on[10+i] > 3) inp = 1;//長押ししたか
  }
  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(selMenu == 0 && flg[FLG_MENU+selMenu] == 1) {
    idx = IDX_MENU_STS;
    selEq = -1;
    tmr = 0;//画面切り替え直後に装備を選ばないようにする
   }
   if(selMenu == 1 && flg[FLG_MENU+selMenu] == 1) {
    idx = IDX_MENU_ITM;
    tmr = 0;//画面切り替え直後に道具を選ばないようにする
   }
   if(selMenu == 2 && flg[FLG_MENU+selMenu] == 1) {
    idx = IDX_MENU_WMAP;
    tmr = 0;
   }
   if(selMenu == 3 && flg[FLG_MENU+selMenu] == 1) {
    if(map_no == 0) {
     idx = IDX_VEH_ON;
     tmr = 0;
    }
    else {
     iMessage("ここでは乗れません", "yellow", 20);
    }
   }
   if(selMenu == 4 && flg[FLG_MENU+selMenu] == 1) {
    idx = IDX_MENU_SAVE;
    tmr = 0;
   }
   if(selMenu == 5 && flg[FLG_MENU+selMenu] == 1) {
    idx = IDX_MENU_LOAD;
    tmr = 0;
    c = loadLS("FILENO");
    if(c != null) selFile = c;//前回セーブしたファイル位置にカーソルを当てる
   }
  }
  if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MOVE;
  break;

  case IDX_MENU_STS://メニュー能力画面
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  x = 360;
  y = 320;
  w = 660;
  h = 448;
  drawMenu(x, y-270, 400, 60);
  fText(sts[selChr].name, x, y-270, FNT_SIZ, "white");
  if(numOfPty >= 2) {//パーティメンバーが２人以上いる時
   drawBtn("←", x-150, y-270, 80, 80, FNT_SIZ, "-white", 22);
   drawBtn("→", x+150, y-270, 80, 80, FNT_SIZ, "-white", 23);
  }
  drawMenu(x, y, w, h);
  y = 144;
  drawChr(obj[selChr].p, x-180-24, y-36, _DirD, false);
  y = 220;
  for(i = 0; i < 3; i++) {
   if(selEq == i) selBar(x-180, y+45, 260, 40);
   fText(ITEM_EQ[i], x-180, y, FNT_SIZ*0.8, "lime");
   drawBtn(itmName(sts[selChr].equip[i]), x-180, y+45, 240, 60, FNT_SIZ, (selEq==i)?"-cyan":"-white", 10+i);
   y += 115;
  }
  x = 400;
  y = 132;
  if(sts[selChr].poison > 0) drawBtlPng(24, x-300, y-20);//毒の印
  fText("Lv "+sts[selChr].lev, x-140, y, FNT_SIZ*0.9, "white");
  fText("経験値",   x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].exp, x+128, y, FNT_SIZ*0.9, "white"); y += 54;
  fText("ＨＰ",     x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].hp+"/"+sts[selChr].mh, x+128, y, FNT_SIZ*0.9, "white"); y += 54;
  fText("ＭＰ",     x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].mp+"/"+sts[selChr].mm, x+128, y, FNT_SIZ*0.9, "white"); y += 54;
  fText("攻撃力",   x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].str, x+128, y, FNT_SIZ, "white"); fText("x"+(itmAtc(selChr)/100), x+230, y, FNT_SIZ*0.9, (selEq==0)?"cyan":"white"); y += 54;
  fText("防御力",   x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].def, x+128, y, FNT_SIZ, "white"); fText("x"+(itmDef(selChr)/100), x+230, y, FNT_SIZ*0.9, (selEq==1)?"cyan":"white"); y += 54;
  fText("知力",     x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].itl, x+128, y, FNT_SIZ, "white"); y += 54;
  fText("魔法防御", x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].mde, x+128, y, FNT_SIZ, "white"); y += 54;
  fText("素早さ",   x, y, FNT_SIZ*0.9, "white"); fText(sts[selChr].mde, x+128, y, FNT_SIZ, "white");

  selPtyLRKey();//左右キーでパーティメンバーを選ぶ

  //装備品の選択
  if(key[38] == 1 || btn_on[0] == 1) { selEq--; if(selEq < 0) selEq = 0; }
  if(key[40] == 1 || btn_on[1] == 1) { selEq++; if(selEq > 2) selEq = 2; }

  inp = 0;
  if(tmr > 5 && imTim == 0) {//【重要】画面押しっぱなしで装備処理が連続して入ることを防ぐ
   for(i = 0; i < 3; i++) {
    if(btn_on[10+i] > 1) selEq = i;//項目を押したか
    if(btn_on[10+i] > 3) inp = 1;//長押ししたか
   }
  }

  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(selEq == 0) { selItmPage = 1 + sts[selChr].gen*2; selItm = 1; idx = IDX_MENU_EQU; tmr = 0; break; }//武器
   if(selEq == 1) { selItmPage = 2 + sts[selChr].gen*2; selItm = 1; idx = IDX_MENU_EQU; tmr = 0; break; }//防具
   if(selEq == 2) { selItmPage = 5;                     selItm = 1; idx = IDX_MENU_EQU; tmr = 0; break; }//アクセサリー
  }
  if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_TOP;//戻る
  break;

  case IDX_MENU_ITM://メニュー　アイテム画面
  case IDX_MENU_EQU://メニュー　装備品選択画面
  case IDX_SELL://売却
  case IDX_SELLNUM://売却個数
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  if(idx != IDX_SELLNUM) escapeKey();
  drawItemMenu(ITEM_CLAS[selItmPage]);

  if(idx == IDX_SELLNUM) {//売却個数を選んで売る
   fRect(0, 0, 720, 720, "rgba(0,0,0,0.6)");
   escapeKey();//ESCの表示が暗くならないよう、ここに
   x = 360;
   y = 310;
   w = 712;
   h = 240;
   drawMenu(x, y, w, h);
   fText(itmName(itemNum), x-160, y-80, FNT_SIZ, "white");
   fText("所持金 " + gold + GOLD, x+160, y-80, FNT_SIZ, "white");
   fText("いくつ売りますか？", x, y, FNT_SIZ, "white");
   price = toInt(itmPrice(itemNum)*selNum/2);//【メモ】売却価格は購入価格の半分で
   fText(selNum, x-160, y+80, FNT_SIZ, "white");
   fText((price)+GOLD, x+160, y+80, FNT_SIZ, "white");
   drawBtn("←", x-160-100, y+80, 80, 80, FNT_SIZ, "-white", 22);
   drawBtn("→", x-160+100, y+80, 80, 80, FNT_SIZ, "-white", 23);
   if(key[37] == 1 || key[37] > 10 || btn_on[2] == 1 || btn_on[2] > 10 || btn_on[22] == 1 || btn_on[22] > 10) {selNum--; if(selNum < 1) selNum = gpv;}
   if(key[39] == 1 || key[39] > 10 || btn_on[3] == 1 || btn_on[3] > 10 || btn_on[23] == 1 || btn_on[23] > 10) {selNum++; if(selNum > gpv) selNum = 1;}
   if(key[32] == 1 || btn_on[4] == 1) {
    itm[itemNum] -= selNum;
    getGold(price);
    iMessage(itmName(itemNum)+"を売りました", "white", 30);
    idx = IDX_SELL;
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_SELL;
   break;
  }

  if(key[38] == 1 || key[38] > 10 || btn_on[0] == 1 || btn_on[0] > 10) {selItm--; if(selItm < 1) selItm = ITM_PER;}
  if(key[40] == 1 || key[40] > 10 || btn_on[1] == 1 || btn_on[1] > 10) {selItm++; if(selItm > ITM_PER) selItm = 1;}

  inp = 0;
  if(tmr > 5) {//【重要】画面切り替え直後に選んでしまうのを防ぐ
   for(i = 1; i <= ITM_PER; i++) {
    if(btn_on[10+i] > 1) selItm = i;//項目を押したか
    if(btn_on[10+i] > 3) inp = 1;//項目を長押ししたか
   }
  }

  if(idx == IDX_MENU_ITM || idx == IDX_SELL) {//アイテム選択
   if(key[37] == 1 || key[37] > 10 || btn_on[2] == 1 || btn_on[2] > 10 || btn_on[22] == 1 || btn_on[22] > 10) {selItmPage--; if(selItmPage < 0) selItmPage = 5;}
   if(key[39] == 1 || key[39] > 10 || btn_on[3] == 1 || btn_on[3] > 10 || btn_on[23] == 1 || btn_on[23] > 10) {selItmPage++; if(selItmPage > 5) selItmPage = 0;}
  }

  if(idx == IDX_MENU_ITM) {//アイテム一覧
   if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
    if(selItmPage == 0) {//消費アイテムを使う？
     c = selItmPage*ITM_PER + selItm;//選んでいるアイテムの番号
     if(itm[c] > 0) {
      if(itmClass(c) == 10) {//魔除け
       if(mayoke > 0) {
        iMessage("魔除け効果が残っています", "white", 30);
       }
       else {
        itm[c]--;
        idx = IDX_MENU_MAYOKE;
        tmr = 0;
        break;
       }
      }
      else if(itmClass(c) == 11) {//出口へ
iMessage("★★★制作中", "white", 30);
      }
      else {
       idx = IDX_MENU_USE;
       tmr = 0;
      }
     }
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_TOP;
  }

  if(idx == IDX_MENU_EQU) {//装備選択
   if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
    c = selItmPage*ITM_PER + selItm;//選んでいるアイテムの番号
    if(itm[c] > 0) {
     if(canEq(selChr,c) == true) {
      iMessage("装備しました", "lime", 30);
      getItm(sts[selChr].equip[selEq], 1);
      sts[selChr].equip[selEq] = c;
      itm[c]--;
      idx = IDX_MENU_STS;
     }
     if(canEq(selChr,c) == false) {
      iMessage("装備できません", "yellow", 30);
     }
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_STS;
  }

  if(idx == IDX_SELL) {//売却
   if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
    if(selItmPage < 6) {//売ってよいもの
     itemNum = selItmPage*ITM_PER + selItm;//選んでいるアイテムの番号
     gpv = itm[itemNum];
     if(gpv > 0) {
      idx = IDX_SELLNUM;
      tmr = 0;
      selNum = 1;
     }
    }
    else {//重要アイテムは売れない
     iMessage("重要品は売れません", "yellow", 30);
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MOVE;
  }
  break;

  case IDX_MENU_USE://メニュー　消費アイテムを使う
  case IDX_BTL_USE://メニュー　戦闘中の消費アイテム使用
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  if(idx == IDX_BTL_USE) drawBTL();
  escapeKey();
  drawItemMenu("誰が使いますか？");
  y = 480;
  miniPara(y);
  if(effRec > 0) {
   x = 90+180*selChr;
   w = 180;
   h = 120;
   fRect(x-w/2, y-h/2, w, h, "rgba(64,192,255,"+(COL_RECA[toInt(effRec/2)]/10)+")");
   effRec--;
   if(effRec == 0) {
    if(idx == IDX_MENU_USE) {//移動シーン
     idx = IDX_MENU_ITM;
     tmr = 0;//画面切り替え直後に道具を選ばないようにする
    }
    if(idx == IDX_BTL_USE) {//戦闘シーン
     idx = IDX_BTL_AFTER;
     tmr = 0;
    }
   }
   break;//演出中は連続して使えないように
  }
  selPtyClick(y);//クリックでパーティメンバーを選ぶ
  selPtyLRKey();//左右キーでパーティメンバーを選ぶ

  inp = 0;
  if(tmr > 5) {//画面押しっぱなしで選んでしまわないように
   for(i=0; i<numOfPty; i++) { if(btn_on[30+i] > 3) inp = 1; }//項目を長押ししたか
  }

  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {//アイテムを使う
   if(useItem(selChr, selItm) == true) effRec = 30;//使った場合は回復演出を行う
   break;
  }

  if(key[27] == 1 || btn_on[6] == 1) {
   if(idx == IDX_MENU_USE) idx = IDX_MENU_ITM;//移動シーン
   if(idx == IDX_BTL_USE) idx = IDX_BTL_ITM;//戦闘シーン
  }
  break;

  case IDX_MENU_MAYOKE://メニュー　魔除け効果の演出
  drawBG();
  drawObj();
  drawFG();
  col = 0.5; if(tmr > 80) col = 0.5*(100-tmr)/20;
  fCir(360, 360, tmr*6, "rgba(255,255,64,"+col+")");
  if(tmr ==  40) iMessage("爽やかな香りが広がり", "white", 40);
  if(tmr ==  80) iMessage("しばらく敵が出なくなった", "white", 40);
  if(tmr == 100) {
   mayoke = 200;
   idx = IDX_MOVE;
   tmr = 0;
  }
  virtualKey();
  break;

  case IDX_MENU_DEGUCHI://メニュー　出口に移動する演出　★★★制作中
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  break;

  case IDX_MENU_WMAP://メニュー　ワールドマップ
  if(tmr ==  1) fRect(0, 0, 720, 720, "black");
  if(tmr <= 12) {
   n = (tmr-1);
   for(y=0; y<120; y+=12) {
    for(x=0; x<120; x++) {
     var gx = 4*x+120;
     var gy = 4*(y+n);
     c = DAT_WORLDMAP[3+x+120*(y+n)];
     if(20 <= c && c <= 28) drawChipS(24, gx, gy, 5);//【開発メモ】One Hour Quest用　海の表示
     drawChipS(c, gx, gy, 5);
    }
   }
  }
  if(map_no == 0) {
   var gx = 4*obj[0].x+120;
   var gy = 4*obj[0].y;
   fRect(gx-2, gy-2, 8, 8, "black");
   fRect(gx-1, gy-1, 6, 6, (tmr%10<5)?"blue":"cyan");
  }
  virtualKey();
  escapeKey();
  if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_TOP;
  break;

  case IDX_MENU_SAVE://メニュー　セーブ
  case IDX_MENU_DOSAVE://メニュー　セーブ？
  case IDX_MENU_LOAD://メニュー　ロード
  case IDX_MENU_DOLOAD://メニュー　ロード？
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  txt = MENU_TOP[selMenu];
  if(idx == IDX_MENU_DOSAVE) txt = "セーブしますか？";
  if(idx == IDX_MENU_DOLOAD) txt = "ロードしますか？";
  x = 360;
  y = 40;
  drawMenu(x, y, 340, 50);
  fText(txt, x, y, FNT_SIZ, "white");
  for(i=0; i<3; i++) {
   x = 360;
   y = 150+160*i;
   drawMenu(x, y, 660, 150);
   drawBtn("", x, y, 640, 120, FNT_SIZ, (selFile==i)?"-cyan":"-white", 20+i);
   if(selFile == i) selBar(x, y, 660, 150);
   if( checkFile(i) == true ) {
    y -= 54;
    for(c=0; c<4; c++) {
     x = 110+c*160;
     if(f_mh[c] > 0) {//仲間になっているなら
      fText(f_name[c], x, y, FNT_SIZ*0.7, "white");
      fText("lv "  + f_lev[c], x, y+35, FNT_SIZ*0.7, "white");
      fText("exp " + f_exp[c], x, y+70, FNT_SIZ*0.7, "white");
      fText(f_hp[c] + "/" + f_mh[c], x, y+105, FNT_SIZ*0.7, "white");
     }
    }
   }
   else {
    fText("No file", x, y, FNT_SIZ, "white");
   }
  }
  if(idx == IDX_MENU_DOSAVE || idx == IDX_MENU_DOLOAD) {
   inputYN(0);//選択肢
  }
  if(tmr <= 5) break;//【重要】画面切り替え直後に選んでしまうのを防ぐ
  if(idx == IDX_MENU_SAVE || idx == IDX_MENU_LOAD) {
   if(key[38] == 1 || key[38] > 10 || btn_on[0] == 1 || btn_on[0] > 10) {selFile--; if(selFile < 0) selFile = 0;}
   if(key[40] == 1 || key[40] > 10 || btn_on[1] == 1 || btn_on[1] > 10) {selFile++; if(selFile > 2) selFile = 2;}
   inp = 0;
   for(i=0; i<3; i++) {
    if(btn_on[20+i] > 1) selFile = i;//項目を押したか
    if(btn_on[20+i] > 3) inp = 1;//項目を長押ししたか
   }
   if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
    if(idx == IDX_MENU_SAVE) {//セーブする？の処理へ
     idx = IDX_MENU_DOSAVE;
     selAns = 1;//不用意にセーブしないように
     tmr = 0;
    }
    if(idx == IDX_MENU_LOAD && checkFile(selFile) == true) {//ロードする？の処理へ
     idx = IDX_MENU_DOLOAD;
     selAns = 0;
     tmr = 0;
    }
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_TOP;
  }
  else if(idx == IDX_MENU_DOSAVE) {
   if(key[32] == 1 || btn_on[4] == 1 || btn_on[10] > 1 || btn_on[11] > 1) {
    if(selAns == 0) {
     saveFile(selFile);
     saveLS("FILENO", selFile);
     iMessage("セーブしました", "cyan", 20);
     idx = IDX_MENU_SAVE;
    }
    else {
     idx = IDX_MENU_SAVE;
    }
    tmr = 0;
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_SAVE;
  }
  else if(idx == IDX_MENU_DOLOAD) {
   if(key[32] == 1 || btn_on[4] == 1 || btn_on[10] > 1 || btn_on[11] > 1) {
    if(selAns == 0) {
     loadFile(selFile);
//     setObj();
     setMap();
     idx = IDX_MOVE;
    }
    else {
     idx = IDX_MENU_LOAD;
    }
    tmr = 0;
   }
   if(key[27] == 1 || btn_on[6] == 1) idx = IDX_MENU_LOAD;
  }
  break;

  case IDX_BTL_INIT://戦闘　初期化　★★★仮実装
  if(tmr == 2) {//パーティの座標をマス目の位置に合わせる
   obj[0].cx = obj[0].x*CHIP_SIZE;
   obj[0].cy = obj[0].y*CHIP_SIZE;
   walkPty();//パーティメンバーをぞろぞろ引き連れて歩く処理
  }
  if(tmr == 10) {//戦闘用の変数
   steps = 0;//エンカウント歩数をリセット
   clrBtlMsg();
   clrBtlVal();

   if(boss_num >= 0) {//ボス戦の場合
    btlBG = 3;
    setChrSts(EMY_TOP+1, boss_num);
   }
   else {
    r = rnd(1000);
    if(r < 100) offensive = 1;
    if(r > 950) offensive = 2;

    var eset = mapAtt[3]*3;//敵のセット
    btlBG = mapAtt[4];//戦闘背景
    if(map_no == 0) {//フィールドの場合
     n = toInt(obj[0].x/15)+8*toInt(obj[0].y/15);
     btlBG = toInt(FIELD_BTLDAT[n]/10);
     eset = toInt(FIELD_BTLDAT[n]%10)*3;
    }
console.log("eset="+eset);//★★★デバッグ
    var emy = [0, 0, 0];
    emy[0] = EMY_SET[eset+0];
    emy[1] = EMY_SET[eset+1];
    emy[2] = EMY_SET[eset+2];

    n = 1+rnd(numOfPty+1);//敵が何体出現するか？
    if(n == 1) {//１体出現
     setChrSts(EMY_TOP+1, emy[rnd(3)]);
    }
    else if(n == 2) {//２体出現
     setChrSts(EMY_TOP+0, emy[rnd(3)]);
     setChrSts(EMY_TOP+2, emy[rnd(3)]);
    }
    else {
     setChrSts(EMY_TOP+0, emy[rnd(3)]);
     setChrSts(EMY_TOP+1, emy[rnd(3)]);
     setChrSts(EMY_TOP+2, emy[rnd(3)]);
    }
   }
  }
  if(tmr < 20) {
   if(tmr%2 == 1) {
    drawBG();
    drawObj();
    drawFG();
    virtualKey();
   }
   else {
    fRect(0, 0, 720, 720, "black");
   }
  }
  else {
   y = -360+30*(tmr-20);
   drawBtlPng(btlBG, 0, y);
  }
  if(tmr == 31) stopBgm();
  if(tmr == 32) playBgm(4);
  if(tmr == 33) {//戦闘開始へ
   if(offensive == 0) {
    setBtlMsg("敵が現れた！");
   }
   if(offensive == 1) {
    setBtlMsg("先制攻撃！");
    for(i=0; i<PTY_MAX; i++) if(sts[i].hp > 0) sts[i].btlTrn = 1000;
   }
   if(offensive == 2) {
    setBtlMsg("敵に不意を突かれた！");
    for(i=0; i<EMY_MAX; i++) if(sts[EMY_TOP+i].hp > 0) sts[EMY_TOP+i].btlTrn = 1000;
   }
   //先制攻撃できる指輪の効果があるか
   for(i=0; i<PTY_MAX; i++) {
    if(sts[i].hp > 0) if(itmLeadoff(i) == true) sts[i].btlTrn = 1000;
   }
   idx = IDX_BTL_START;
   tmr = 0;
  }
  break;

  case IDX_BTL_START://戦闘　開始
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  if(tmr == 30) {
   idx = IDX_BTL_TURN;
   tmr = 0;
  }
  break;

  case IDX_BTL_TURN://戦闘　行動するキャラを決める
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  for(i=0; i<PTY_MAX+EMY_MAX; i++) {
   if(sts[i].hp > 0) {
    sts[i].btlTrn = sts[i].btlTrn + 100 + sts[i].agi;
    if(sts[i].btlTrn > 1000) {
     sts[i].btlTrn = 0;
     //【開発メモ】一定ターンで効果が消えるもの
     if(sts[i].btlAtc > 0) sts[i].btlAtc--;
     sts[i].btlDef = 0;
     if(i < PTY_MAX) {//プレイヤーの行動
      btlAct = i;
　    if(sts[EMY_TOP+selEmy].hp == 0) {
  　   for(j=0; j<EMY_MAX; j++) if(sts[EMY_TOP+j].hp > 0) { selEmy = j; break; }
    　}
      idx = IDX_BTL_CMD;
     }
     else {//敵の行動
      btlAct = i;
      btlTgt = rnd(PTY_MAX);
      while(sts[btlTgt].hp == 0) {
       btlTgt--;
       if(btlTgt < 0) btlTgt = PTY_MAX-1;
      }
      //敵がスキルを使うか？
      if(sts[btlAct].gen != SKL_NONE) {
       sklNum = sts[btlAct].gen;
       if(sts[btlAct].mp >=  SKILL[sklNum*3+2]) {
        if(sts[btlAct].gen == SKL_NAGI || sts[btlAct].gen == SKL_OUEN || sts[btlAct].gen == SKL_MEISO) {
         idx = IDX_BTL_USESKL;
        }
        if(sts[btlAct].gen == SKL_KOORI || sts[btlAct].gen == SKL_DOKU) {
         sklAtc = true;
         idx = IDX_BTL_ATTACK;
        }
        if(idx != IDX_BTL_TURN) {
         sts[btlAct].mp -= SKILL[sklNum*3+2];
         tmr = 0;
         break;
        }
       }
      }
      //スキルを使わない場合は通常攻撃
      sklNum = SKL_NONE;
      sklAtc = false;
      idx = IDX_BTL_ATTACK;
      tmr = 0;
     }
     break;
    }
   }
  }
  break;

  case IDX_BTL_CMD://戦闘　コマンド入力
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("コマンド選択");
  drawArrow(38+180*btlAct, 415+(toInt(tmr/5)%3)*4);
  x = 640;
  y = 120;
  if(key[38] == 1 || key[38] > 10 || btn_on[0] == 1 || btn_on[0] > 10) {btlCmd--; if(btlCmd < 0) btlCmd = 4;}
  if(key[40] == 1 || key[40] > 10 || btn_on[1] == 1 || btn_on[1] > 10) {btlCmd++; if(btlCmd > 4) btlCmd = 0;}
  for(i=0; i<5; i++) {
   var siz = FNT_SIZ;
   if(i == 1) siz *= 0.9;//スキルの文字の大きさ
   drawBtn(BTL_CMD[i], x, y, 120, 60, siz, (btlCmd==i)?"cyan":"white", 10+i);
   y += 60;
  }
  inp = 0;
  for(i=0; i<5; i++) {
   if(btn_on[10+i] > 1) btlCmd = i;//項目を押したか
   if(btn_on[10+i] > 3) inp = 1;//長押ししたか
  }
  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(btlCmd == 0) {//攻撃
    idxBk = idx;//キャンセルした時、どこに戻るか
    sklNum = SKL_NONE;
    sklAtc = false;
    idx = IDX_BTL_SELEMY;
    tmr = 0;
   }
   if(btlCmd == 1) {//魔法→このゲームではスキル
    idx = IDX_BTL_SELSKL;
   }
   if(btlCmd == 2) {//道具
    selItmPage = 0;
    if(selItm < 1 || selItm > 6) selItm = 1;
    idx = IDX_BTL_ITM;
    tmr = 0;
   }
   if(btlCmd == 3) {//防御
    idx = IDX_BTL_DEF;
    tmr = 0;
   }
   if(btlCmd == 4) {//撤退
    if(boss_num == -1) {
     btlEsc++;
     idx = IDX_BTL_ESCAPE;
     tmr = 0;
    }
    else {
     iMessage("この相手からは逃げられない！", "yellow", 20);
    }
   }
  }
  break;

  case IDX_BTL_SELSKL://戦闘　スキルを選択
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawBTL();
  sklNum = 0;//使えるスキルの番号
  if(sts[btlAct].img == _BRAVEMAN) sklNum = SKL_NAGI;
  if(sts[btlAct].img == _PRINCESS) sklNum = SKL_OUEN;
  if(sts[btlAct].img == _SOLDIER)  sklNum = SKL_MEISO;
  if(sts[btlAct].img == _QUEEN)    sklNum = SKL_KOORI;
  drawBBar("消費MP "+SKILL[sklNum*3+2]);
  i = sklNum;//【開発メモ】今回は学習用に１キャラ固有スキルに
  x = 360;
  y = 360;
  drawBtn("", x, y, 640, 60, FNT_SIZ, "white", 10+i);
  col = "white";
  if(sklNum == i) col = "cyan";
  fText(SKILL[i*3],   x-210, y+2, FNT_SIZ*1.1, "black");
  fText(SKILL[i*3+1], x+100, y+2, FNT_SIZ, "black");
  fText(SKILL[i*3],   x-210, y, FNT_SIZ*1.1, col);
  fText(SKILL[i*3+1], x+100, y, FNT_SIZ, col);
  inp = 0;
  if(btn_on[10+i] > 3) inp = 1;//長押ししたか
  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(sts[btlAct].mp < SKILL[sklNum*3+2]) {
    iMessage("MPが足りない", "yellow", 20);
   }
   else {
    if(sklNum == SKL_KOORI) {//敵を選ぶスキルの場合
     idxBk = idx;//キャンセルした時、どこに戻るか
     sklAtc = true;
     idx = IDX_BTL_SELEMY;
     tmr = 0;
    }
    else {
     sts[btlAct].mp -= SKILL[sklNum*3+2];
     idx = IDX_BTL_USESKL;
     tmr = 0;
    }
   }
  }
  if(key[27] == 1 || btn_on[6] == 1) idx = IDX_BTL_CMD;
  break;

  case IDX_BTL_USESKL://戦闘　スキルを使う
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawBTL();
  drawBBar("");
  if(tmr ==  1) {
   if(sklNum == SKL_NAGI ) setBtlMsg(sts[btlAct].name+"は"+SKILL[sklNum*3]+"を使った！");
   if(sklNum == SKL_OUEN ) setBtlMsg(sts[btlAct].name+"は仲間達を応援した！");
   if(sklNum == SKL_MEISO) setBtlMsg(sts[btlAct].name+"は精神を集中した！");
  }
  if(tmr == 21) {
   if(sklNum == SKL_NAGI) {
    idx = IDX_BTL_ATCALL;
    tmr = 0;
//    btlTgt = EMY_TOP;
   }
   bsn = 0;
   ben = PTY_MAX;
   if(btlAct >= PTY_MAX) {
    bsn = EMY_TOP;
    ben = EMY_TOP+EMY_MAX;
   }
   if(sklNum == SKL_OUEN) {
    for(i=bsn; i<ben; i++) if(sts[i].hp > 0) sts[i].btlAtc = 3;
    setBtlMsg("仲間達の攻撃力がアップした！");
   }
   if(sklNum == SKL_MEISO) {
    setBtlMsg(sts[btlAct].name+"は回復した！");
    sts[btlAct].hp = sts[btlAct].mh;
    sts[btlAct].poison = 0;
   }
  }
  if(tmr == 51) {
   idx = IDX_BTL_AFTER;
   tmr = 0;
  }
  break;

  case IDX_BTL_SELEMY://戦闘　敵を選択
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawBTL();
  drawBBar("誰を？");
  for(i=0; i<EMY_MAX; i++) {
   x = 120+240*i;	//┬敵の足元の中心の位置
   y = 420;			//┘
   drawBtn("", x, y-190, 200, 280, FNT_SIZ, (selEmy==i)?"-cyan":"-white", 10+i);
   if(i == selEmy) {
    fText(sts[selEmy+EMY_TOP].name, x, y-280, FNT_SIZ*0.8, "black");
    fText(sts[selEmy+EMY_TOP].name, x, y-282, FNT_SIZ*0.8, "white");
    drawArrow(x, y-320+(toInt(tmr/5)%3)*4);
   }
  }
  if(tmr < 5) break;//タップが連続して入らないように
  if(key[37] == 1 || key[37] > 10 || btn_on[2] == 1 || btn_on[2] > 10) {
   while(true) { selEmy--; if(selEmy < 0) selEmy = EMY_MAX-1; if(sts[selEmy+EMY_TOP].hp > 0) break; }
  }
  if(key[39] == 1 || key[39] > 10 || btn_on[3] == 1 || btn_on[3] > 10) {
   while(true) { selEmy++; if(selEmy > EMY_MAX-1) selEmy = 0; if(sts[selEmy+EMY_TOP].hp > 0) break; }
  }
  inp = 0;
  for(i=0; i<EMY_MAX; i++) {
   if(btn_on[10+i] > 1) if(sts[i+EMY_TOP].hp > 0) selEmy = i;//項目を押したか
   if(btn_on[10+i] > 3) if(sts[i+EMY_TOP].hp > 0) inp = 1;//長押ししたか
  }
  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(sklAtc == true) sts[btlAct].mp -= SKILL[sklNum*3+2];
   btlTgt = selEmy + EMY_TOP;
   idx = IDX_BTL_ATTACK;
   tmr = 0;
  }
  if(key[27] == 1 || btn_on[6] == 1) idx = idxBk;
  break;

  case IDX_BTL_ITM://戦闘中の消費アイテム選択
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawBTL();
  drawItemMenu(ITEM_CLAS[selItmPage]);
  if(key[38] == 1 || key[38] > 10 || btn_on[0] == 1 || btn_on[0] > 10) {selItm--; if(selItm < 1) selItm = 6;}
  if(key[40] == 1 || key[40] > 10 || btn_on[1] == 1 || btn_on[1] > 10) {selItm++; if(selItm > 6) selItm = 1;}
  inp = 0;
  if(tmr > 5) {//【重要】画面切り替え直後に選んでしまうのを防ぐ
   for(i = 1; i <= 6; i++) {
    if(btn_on[10+i] > 1) selItm = i;//項目を押したか
    if(btn_on[10+i] > 3) inp = 1;//項目を長押ししたか
   }
  }
  if(inp == 1 || key[32] == 1 || btn_on[4] == 1) {
   if(itm[selItm] > 0) {
    idx = IDX_BTL_USE;
    tmr = 0;
   }
  }
  if(key[27] == 1 || btn_on[6] == 1) idx = IDX_BTL_CMD;
  break;

  case IDX_BTL_DEF://戦闘　防御
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  //敵、プレイヤー共通の処理
  if(tmr ==  1) {
   setBtlMsg(sts[btlAct].name+"は防御している");
   sts[btlAct].btlDef = 1;
  }
  if(tmr == 31) {
   idx = IDX_BTL_AFTER;
   tmr = 0;
  }
  break;

  case IDX_BTL_ESCAPE://戦闘　逃げられるか
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  escapeKey();
  drawBTL();
  drawBBar("");
  if(tmr ==  1) {
   if(numOfPty == 1)
    setBtlMsg(sts[btlAct].name+"は撤退した");
   else
    setBtlMsg(sts[btlAct].name+"達は撤退した");
  }
  if(tmr == 31) {
   if(rnd(100) < 50+btlEsc*10) {
    clrSts(EMY_TOP+0);
    clrSts(EMY_TOP+1);
    clrSts(EMY_TOP+2);
    stopBgm();//一旦停止する
    idx = IDX_BTL_END;
   }
   else {
    setBtlMsg("しかし敵に回りこまれた！");
   }
  }
  if(tmr == 50) {
   idx = IDX_BTL_AFTER;
   tmr = 0;
  }
  break;

  case IDX_BTL_ATTACK://戦闘　単体攻撃
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  //敵、プレイヤー共通の処理
  if(tmr == 1) {
   crit = 0;
   miss = 0;
   if(sklAtc == false) {
    setBtlMsg(sts[btlAct].name+"の攻撃！");
    sts[btlTgt].btlEfNum = -1;//敵→剣の軌跡　【開発メモ】スキルの値と被らないように-1で指定
    sts[btlTgt].btlEfTmr = 8;
   }
   else {//スキルごとのエフェクト
    if(sklNum == SKL_KOORI) {
     setBtlMsg(sts[btlAct].name+"は冷気を吐き出した！");
     sts[btlTgt].btlEfNum = sklNum;
     sts[btlTgt].btlEfTmr = 20;
    }
    if(sklNum == SKL_DOKU) {
     setBtlMsg(sts[btlAct].name+"は毒針を突き刺した！");
    }
   }
  }
  if(tmr == 10) {//ダメージの計算
   var offense = toInt(sts[btlAct].str*itmAtc(btlAct)/100);//攻撃力　武器加算
   if(sts[btlAct].btlAtc > 0) offense *= 2;//攻撃力アップ中
   if(sklAtc == true) offense = sts[btlAct].itl;//スキルの場合は知力で計算
console.log("offense="+offense);//★★★開発中
   var defence = toInt(sts[btlTgt].def*itmDef(btlTgt)/100);//防御力　防具加算
   if(sklAtc == true) defence = sts[btlTgt].mde;//スキルの場合は魔法防御で計算
console.log("defence="+defence);//★★★開発中
   dmg[btlTgt] = offense - defence;
   if(dmg[btlTgt] < 0) dmg[btlTgt] = 0;
   if(sts[btlTgt].btlDef > 0) dmg[btlTgt] = toInt(dmg[btlTgt]/3);//防御している場合
   dmg[btlTgt] += rnd(2);
   if(sklAtc == false) {//物理攻撃でクリティカル及び攻撃失敗する処理
    r = rnd(1000);
    if(r < sts[btlAct].cri) {
     setBtlMsg("クリティカルヒット！");
     crit = 1;
     dmg[btlTgt] = dmg[btlTgt]*3 + 10;
    }
    else if(r > 950) {//攻撃失敗→このゲームでは相手が攻撃をかわしたことにする
     miss = 1;//【開発メモ】全キャラ一律この確率　→　キャラのパラメータや武器の能力値として定義すると個性が出る
     dmg[btlTgt] = 0;
    }
   }
   else {//スキルで物理攻撃する際の特別な処理
    if(sklNum == SKL_DOKU) dmg[btlTgt] = 1;//毒針は固定ダメージ
   }
   if(dmg[btlTgt] > 0) mpShake[btlTgt] = 16;//ダメージ演出
  }
  if(tmr == 30) {
   if(sklNum == SKL_DOKU) {
    if(itmAcc(btlTgt) == ACC_NOPOISON) {
     setBtlMsg("指輪が毒を防いだ！");
    }
    else {
     setBtlMsg(sts[btlTgt].name+"は毒を受けた！");
     sts[btlTgt].poison = 10;
    }
   }
   else if(dmg[btlTgt] > 0) {
    setBtlMsg(sts[btlTgt].name+"は" + dmg[btlTgt] + "のダメージを受けた");
   }
   else {
    if(miss == 0)
     setBtlMsg(sts[btlTgt].name+"はダメージを受けない");
    else
     setBtlMsg(sts[btlTgt].name+"は攻撃をかわした！");
   }
  }
  if(tmr == 40) {
   sts[btlTgt].hp -= dmg[btlTgt];
   if(sts[btlTgt].hp <= 0) {
    sts[btlTgt].hp = 0;
    if(btlAct < PTY_MAX) {//敵を倒した時に貰える経験値とゴールド
     getExp += sts[btlTgt].exp;
     getGld += sts[btlTgt].gld*itmGldPls(btlAct);
    }
   }
  }
  if(tmr == 50) {
   if(sts[btlTgt].hp == 0) {
    if(btlAct < PTY_MAX) {
     setBtlMsg(sts[btlTgt].name+"を倒した！");
    }
    else {
     setBtlMsg(sts[btlTgt].name+"は倒れた...");
    }
   }
  }
  if(tmr == 70) {
   idx = IDX_BTL_AFTER;
   tmr = 0;
  }
  //以下、個別の処理
  if(btlAct < PTY_MAX) {//プレイヤー→敵を攻撃
   if(miss == 1) {//攻撃を失敗した時
    if(10 <= tmr && tmr <= 12) emyXP[btlTgt-EMY_TOP] += 10;
    if(tmr == 13) emyXP[btlTgt-EMY_TOP] = 0;
   }
  }
  else {//敵→プレイヤーを攻撃
   if(tmr <=  4) emyYP[btlAct-EMY_TOP] = tmr*8;//敵の動き
   if(tmr == 30) emyYP[btlAct-EMY_TOP] = 0;
  }
  break;

  case IDX_BTL_ATCALL://戦闘　全体攻撃
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  //スキルごとのエフェクト
  if(sklNum == SKL_NAGI) {
   if(btlAct < PTY_MAX) {//プレイヤーが敵を攻撃
    if(tmr == 2) fRect(0, 60, 720, 360, "white");
    if(tmr < 10) {
     setAlp(100-10*tmr);
     drawBtlPng(21, 60, 200);
     setAlp(100);
    }
   }
   else {//敵がプレイヤーを攻撃
    if(tmr == 2) fRect(0, 420, 720, 120, "white");
    if(tmr < 10) {
     setAlp(100-10*tmr);
     drawBtlPng(21, 60, 420);
     setAlp(100);
    }
   }
  }
  //敵、プレイヤー共通の処理
  if(tmr == 10) {//ダメージの計算
   bsn = 0;
   ben = PTY_MAX;
   if(btlAct < PTY_MAX) {
    bsn = EMY_TOP;
    ben = EMY_TOP+EMY_MAX;
   }
   for(i=bsn; i<ben; i++) {
    dmg[i] = -1;
    if(sts[i].hp == 0) continue;
    var offense = toInt(sts[btlAct].str*itmAtc(btlAct)/100);//攻撃力　武器加算
    if(sts[btlAct].btlAtc > 0) offense *= 2;//攻撃力アップ中
console.log("offenseA="+offense);//★★★開発中
    var defence = toInt(sts[i].def*itmDef(i)/100);//防御力　防具加算
console.log("defenceA="+defence);//★★★開発中
    dmg[i] = offense - defence;
    if(dmg[i] < 0) dmg[i] = 0;
    if(sts[i].btlDef > 0) dmg[i] = toInt(dmg[i]/3);//防御している場合
    dmg[i] += rnd(2);
    if(dmg[i] > 0) mpShake[i] = 16;//ダメージ演出
   }
  }
  if(tmr == 30) {
   var txt = "";
   for(i=bsn; i<ben; i++) {
    if(dmg[i] >= 0) txt = txt + " " + dmg[i];
   }
   if(btlAct < PTY_MAX)
    setBtlMsg(txt + "のダメージを与えた！");
   else
    setBtlMsg(txt + "のダメージを受けた！");
  }
  if(tmr == 40) {
   for(i=bsn; i<ben; i++) {
    if(dmg[i] > 0) {
     sts[i].hp -= dmg[i];
     if(sts[i].hp <= 0) {
      sts[i].hp = 0;
      dmg[i] = -2;//【重要】敵を倒したフラグとして活用
      if(btlAct < PTY_MAX) {//敵を倒した時に貰える経験値とゴールド
       getExp += sts[i].exp;
       getGld += sts[i].gld*itmGldPls(btlAct);
      }
     }
    }
   }
  }
  if(tmr == 50) {
   n = 0;
   for(i=bsn; i<ben; i++) if(dmg[i] == -2) n++
   if(n > 0) {
    if(btlAct < PTY_MAX) {
     setBtlMsg("敵を " + n + "体倒した！");
    }
    else {
     setBtlMsg("仲間が " + n + "人倒れた...");
    }
   }
  }
  if(tmr == 70) {
   idx = IDX_BTL_AFTER;
   tmr = 0;
  }
  //以下、個別の処理
  if(btlAct < PTY_MAX) {//プレイヤー→敵を攻撃
   //現状、処理不要
  }
  else {//敵→プレイヤーを攻撃
   if(tmr <=  4) emyYP[btlAct-EMY_TOP] = tmr*8;//敵の動き
   if(tmr == 30) emyYP[btlAct-EMY_TOP] = 0;
  }
  break;

  case IDX_BTL_AFTER://戦闘　行動後の処理　毒の場合は体力を減らす
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  if(tmr == 1 && sts[btlAct].poison == 0) {
   idx = IDX_BTL_VIORDE;
   break;
  }
  if(tmr == 10) {
   dmg[btlAct] = toInt(sts[btlAct].mh/10)+rnd(2);
   setBtlMsg(sts[btlAct].name + "は" + dmg[btlAct] + "の毒ダメージ！");
   mpShake[btlAct] = 4;//ちょっとだけ揺らす
  }
  if(tmr == 30) {
   sts[btlAct].hp -= dmg[btlAct];
   sts[btlAct].poison--;
   if(sts[btlAct].hp <= 0) {
    sts[btlAct].hp = 0;
    if(btlAct >= EMY_TOP) {//敵を倒した時に貰える経験値とゴールド
     getExp += sts[btlAct].exp;
     getGld += sts[btlAct].gld;
    }
    setBtlMsg(sts[btlAct].name + "は倒れた");
   }
  }
  if(tmr == 50) idx = IDX_BTL_VIORDE;
  break;

  case IDX_BTL_VIORDE://戦闘　勝敗判定
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  sklNum = SKL_NONE;//【開発メモ】重要　ここでスキルの番号を解除しておく
  c = 0; for(i=0; i<PTY_MAX; i++) c += sts[i].hp;
  if(c == 0) { idx = IDX_BTL_LOSE; tmr = 0; break; }
  c = 0; for(i=0; i<EMY_MAX; i++) c += sts[EMY_TOP+i].hp;
  if(c == 0) { idx = IDX_BTL_WIN; tmr = 0; break; }
  idx = IDX_BTL_TURN;
  break;

  case IDX_BTL_WIN://戦闘　勝利
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("勝利！");
  if(tmr == 1) stopBgm();
  if(tmr == 2) playSE(0);
  if(tmr == 20) {
   if(numOfPty == 1)
    setBtlMsg(sts[0].name + "は戦いに勝った！");
   else
    setBtlMsg(sts[0].name + "達は戦いに勝った！");
  }
  if(tmr == 40) {//もらえる経験値の計算
   n = 0;
   for(i=0; i<PTY_MAX; i++) if(sts[i].hp > 0) n++;
   getExp = toInt(getExp/n);
   if(getExp < 1) getExp = 1;
   if(n == 1)
    setBtlMsg(getExp + " の経験値を獲得！");
   else
    setBtlMsg("それぞれ " + getExp + " の経験値を獲得！");
   for(i=0; i<PTY_MAX; i++) if(sts[i].hp > 0) sts[i].exp += getExp * itmExp(i);
  }
  if(tmr == 60) {
   setBtlMsg(getGld + GOLD + "を獲得！");
   gold += getGld;
  }
  if(tmr == 80) {
   idx = IDX_BTL_CHKLVUP;
   tmr = 0;
   btlAct = 0;
  }
  break;

  case IDX_BTL_CHKLVUP://戦闘　レベルアップ？
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  if(sts[btlAct].hp > 0) {
   if(sts[btlAct].exp >= 5*sts[btlAct].lev*sts[btlAct].lev) {
    idx = IDX_BTL_LVUP;
    tmr = 0;
    break;
   }
  }
  btlAct++;
  if(btlAct >= PTY_MAX) idx = IDX_BTL_END;
  break;

  case IDX_BTL_LVUP://戦闘　レベルアップ
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("レベルアップ！");
  if(tmr == 10) {
   sts[btlAct].lev++;
   //【開発メモ】パラメータがいくつ増えるか　現状ランダムだが、キャラごとに成長率のデータを用意するとキャラの特徴が出せる
   pls_mh = 10+rnd(5); sts[btlAct].mh  += pls_mh;
   pls_mm =  5+rnd(5); sts[btlAct].mm  += pls_mm;
   pls_st =  3+rnd(3); sts[btlAct].str += pls_st;
   pls_de =  2+rnd(3); sts[btlAct].def += pls_de;
   pls_in =  1+rnd(3); sts[btlAct].itl += pls_in;
   pls_md =  1+rnd(3); sts[btlAct].mde += pls_md;
   pls_ag =  2+rnd(3); sts[btlAct].agi += pls_ag;
   setBtlMsg(sts[btlAct].name + "はレベル " + sts[btlAct].lev + " に成長！");
   playSE(2);
  }
  if(tmr == 30) setBtlMsg("最大ＨＰ+" + pls_mh + "　最大ＭＰ+" + pls_mm);
  if(tmr == 50) setBtlMsg("攻撃力+" + pls_st + "　防御力+" + pls_de);
  if(tmr == 70) setBtlMsg("知力+" + pls_in + "　魔法防御+" + pls_md + "　素早さ+" + pls_ag);
  if(tmr == 90) idx = IDX_BTL_CHKLVUP;
  break;

  case IDX_BTL_LOSE://戦闘　敗北
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  if(tmr < 160) {
   drawBTL();
   drawBBar("");
   if(tmr == 1) stopBgm();
   if(tmr == 2) playSE(1);
   if(tmr == 40) {
    if(numOfPty == 1)
     setBtlMsg(sts[0].name + "は負けてしまった...");
    else
     setBtlMsg(sts[0].name + "達は負けてしまった...");
   }
   if(tmr > 120) fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*(tmr-120)+")");
  }
  else if(tmr < 200) {
   if(tmr == 160) {
    if(bgmBak >= 0) playBgm(bgmBak);//移動画面のＢＧＭを出力
    gold = toInt(gold/2);//所持金半分に
    recPty(-1);//全メンバー完全回復
    gotoPty(8, 7, 7, 0);//王様の前に移動
   }
   fRect(0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*(200-tmr)+")");
  }
  else {
   talkNum = TN_RESTART;//王様のセリフ
   idx = IDX_TALK;
   tmr = 0;
  }
  break;

  case IDX_BTL_END://戦闘　終了
  drawBG();
  drawObj();
  drawFG();
  virtualKey();
  drawBTL();
  drawBBar("");
  if(bgmBak >= 0) playBgm(bgmBak);//移動画面のＢＧＭを出力
  clrBtlVal();//【開発メモ】能力アップなどの変数を解除する
  for(i=0; i<10; i++) {
   if(obj[i].type == OBJ_PTY) {//メンバーが存在し
    if(sts[i].hp == 0) {
     sts[i].hp = 1;
     sts[i].poison = 0;
    }
   }
  }
  if(boss_num >= 0) {//ボスを倒した場合は、会話処理へ
   idx = IDX_TALK;
   tmr = -2;
  }
  else {
   idx = IDX_MOVE;
  }
  break;

 }

 iMessageDraw();

//★★★デバッグ　フラグの値を表示する
if( DBG_PRT ) {//★★★デバッグ
if(idx==IDX_MENU_TOP) {
 if(inkey == 65) {dbgFlg-=20; if(dbgFlg<0)dbgFlg=FLG_MAX-20; }
 if(inkey == 90) {dbgFlg+=20; if(dbgFlg>=FLG_MAX-20)dbgFlg=0; }
 fRect(20, 20, 680, 100, "rgba(0,0,0,0.5)");
 for(y=0;y<5;y++){
  fText((dbgFlg+y*20)%FLG_MAX, 40, 30+20*y, 14, "lime");
  for(x=0;x<20;x++){
  i=(dbgFlg+x+y*20)%FLG_MAX;
  fText(flg[i],70+32*x,30+20*y,12,(flg[i]==1)?"red":"white");
  }
 }
} else {
 fText( mapname, 100, 30, 24, "white" );
 fText( "X="+obj[0].x+" Y="+obj[0].y+" D="+obj[0].d1+" map_no="+map_no, 400, 30, 24, "white" );
 fText( ""+idx+":"+tmr, 100, 60, 24, "cyan" );
 fText( "inkey="+inkey+" vkey="+vkey, 400, 90, 24, "yellow" );
 fText( "CX="+obj[0].cx+" CY="+obj[0].cy+" plWalk="+plWalk+" steps="+steps, 400, 60, 24, "white" );
 fText( "bgmBak="+bgmBak+" BGM番号="+mapAtt[2]+" 敵セット="+mapAtt[3], 400, 120, 24, "cyan" );
// fText( "key[32]="+key[32]+" btn_on[4]="+btn_on[4], 400, 150, 24, "pink" );
 if( plWalk == 0 ) fText( chipNo(obj[0].x,obj[0].y) + "/" + chkWall(0,obj[0].d1) + "/" + chkObj(0,obj[0].d1), 360, 150, 24, "yellow" );
 fText( "wX="+worldX+" wY="+worldY, 400, 180, 24, "lime" );
}

}

 //ブラウザのサイズが変化したか？（スマホなら持ち方を変えたか　縦持ち⇔横持ち）
 w = window.innerWidth;
 h = window.innerHeight;
 if(winW != w || winH != h) {
  winW = w;
  winH = h;
  resizeCanvas();
 }

}

//セーブ、ロード処理
function saveFile( fno ) {
 var i, p;
 fno = (fno+1)*10000;
 saveLS(fno+0, 1);
 saveLS(fno+1, gold);
 saveLS(fno+2, steps);
 saveLS(fno+3, mayoke);
 saveLS(fno+4, vehicle);
 saveLS(fno+5, map_no);
 saveLS(fno+6, worldX);
 saveLS(fno+7, worldY);
 saveLS(fno+8, numOfPty);
 saveLS(fno+9, objMax);

 for(i = 0; i < FLG_MAX; i++) saveLS(fno+1000+i, flg[i]);
 for(i = 0; i < ITM_MAX; i++) {
  saveLS(fno+2000+i, itf[i]);
  saveLS(fno+2500+i, itm[i]);
 }
 for(i = 0; i < PTY_MAX; i++) {//【開発メモ】オブジェクトのプロパティを丸々保存できる環境ならそうする
  p =50*i;
  saveLS(fno+3000+p, sts[i].name);
  saveLS(fno+3001+p, sts[i].lev);
  saveLS(fno+3002+p, sts[i].exp);
  saveLS(fno+3003+p, sts[i].mh);
  saveLS(fno+3004+p, sts[i].hp);
  saveLS(fno+3005+p, sts[i].mm);
  saveLS(fno+3006+p, sts[i].mp);
  saveLS(fno+3007+p, sts[i].str);
  saveLS(fno+3008+p, sts[i].def);
  saveLS(fno+3009+p, sts[i].itl);
  saveLS(fno+3010+p, sts[i].mde);
  saveLS(fno+3011+p, sts[i].agi);
  saveLS(fno+3012+p, sts[i].cri);
  saveLS(fno+3013+p, sts[i].equip[0]);
  saveLS(fno+3014+p, sts[i].equip[1]);
  saveLS(fno+3015+p, sts[i].equip[2]);
  saveLS(fno+3016+p, sts[i].gen);
  saveLS(fno+3017+p, sts[i].img);
//  saveLS(fno+3018+p, sts[i].gld;//保存不要な変数
//  saveLS(fno+3019+p, sts[i].itm);
  saveLS(fno+3020+p, sts[i].poison);
 }

 for(i = 0; i < OBJ_MAX; i++) {
  p =20*i;
  saveLS(fno+4000+p, obj[i].type);
  saveLS(fno+4001+p, obj[i].x);
  saveLS(fno+4002+p, obj[i].y);
  saveLS(fno+4003+p, obj[i].cx);
  saveLS(fno+4004+p, obj[i].cy);
  saveLS(fno+4005+p, obj[i].p);
  saveLS(fno+4006+p, obj[i].d1);
  saveLS(fno+4007+p, obj[i].d2);
  saveLS(fno+4008+p, obj[i].d3);
  saveLS(fno+4009+p, obj[i].d4);
  saveLS(fno+4010+p, obj[i].d5);
  saveLS(fno+4011+p, obj[i].flg);
 }
}

function loadFile( fno ) {
 var i, p;
 fno = (fno+1)*10000;
 var ret = loadLS(fno+0);
 gold = loadLS(fno+1);
 steps = loadLS(fno+2);
 mayoke = loadLS(fno+3);
 vehicle = loadLS(fno+4);
 map_no = loadLS(fno+5);
 worldX = loadLS(fno+6);
 worldY = loadLS(fno+7);
 numOfPty = loadLS(fno+8);
 objMax = loadLS(fno+9);

 for(i = 0; i < FLG_MAX; i++) flg[i] = loadLS(fno+1000+i);
 for(i = 0; i < ITM_MAX; i++) {
  itf[i] = loadLS(fno+2000+i);
  itm[i] = loadLS(fno+2500+i);
 }
 for(i = 0; i < PTY_MAX; i++) {//【開発メモ】オブジェクトのプロパティを丸々保存できる環境ならそうする
  p =50*i;
  sts[i].name = loadLS(fno+3000+p);
  sts[i].lev = loadLS(fno+3001+p);
  sts[i].exp = loadLS(fno+3002+p);
  sts[i].mh = loadLS(fno+3003+p);
  sts[i].hp = loadLS(fno+3004+p);
  sts[i].mm = loadLS(fno+3005+p);
  sts[i].mp = loadLS(fno+3006+p);
  sts[i].str = loadLS(fno+3007+p);
  sts[i].def = loadLS(fno+3008+p);
  sts[i].itl = loadLS(fno+3009+p);
  sts[i].mde = loadLS(fno+3010+p);
  sts[i].agi = loadLS(fno+3011+p);
  sts[i].cri = loadLS(fno+3012+p);
  sts[i].equip[0] = loadLS(fno+3013+p);
  sts[i].equip[1] = loadLS(fno+3014+p);
  sts[i].equip[2] = loadLS(fno+3015+p);
  sts[i].gen = loadLS(fno+3016+p);
  sts[i].img = loadLS(fno+3017+p);
  sts[i].poison = loadLS(fno+3020+p);
 }
 for(i = 0; i < OBJ_MAX; i++) {
  p =20*i;
  obj[i].type = loadLS(fno+4000+p);
  obj[i].x = loadLS(fno+4001+p);
  obj[i].y = loadLS(fno+4002+p);
  obj[i].cx = loadLS(fno+4003+p);
  obj[i].cy = loadLS(fno+4004+p);
  obj[i].p = loadLS(fno+4005+p);
  obj[i].d1 = loadLS(fno+4006+p);
  obj[i].d2 = loadLS(fno+4007+p);
  obj[i].d3 = loadLS(fno+4008+p);
  obj[i].d4 = loadLS(fno+4009+p);
  obj[i].d5 = loadLS(fno+4010+p);
  obj[i].flg = loadLS(fno+4011+p);
 }
}

//セーブデータが存在するか
var f_mno, f_wx, f_wy;
var f_name = [], f_lev = [], f_exp = [], f_mh = [], f_hp = [];
function checkFile( fno ) {
 var i, p;
 fno = (fno+1)*10000;
 if(loadLS(fno+0) != null) {
  f_mno = loadLS(fno+5);
  f_wx = loadLS(fno+6);
  f_wy = loadLS(fno+7);
  for(i=0; i<4; i++) {
   p = 50*i;
   f_name[i] = loadLS(fno+3000+p);
   f_lev[i]  = loadLS(fno+3001+p);
   f_exp[i]  = loadLS(fno+3002+p);
   f_mh[i]   = loadLS(fno+3003+p);
   f_hp[i]   = loadLS(fno+3004+p);
  }
  return true;
 }
 return false;
}

//【メモ】メイン処理と描画処理を分ける場合、描画処理をここに記載
function drawProc() {}
